<?php
	// VERIFY FOLDER ID
	if (!$mg2->getFolderSettings($folderID)) {
		$mg2->setStatus(sprintf('%s #%d', $mg2->lang['nofolderid'],	$folderID), 3);
		$display = 'tableview';
		return false;
	}

	// GET CONTAINED FOLDERS AND ITEMS
	$mg2->folderIDs  = $mg2->selectIndexDB($folderID, 'all_folders', 1);
	$mg2->itemIDs	  = $mg2->selectIndexDB($folderID, 'all_items', 1);
	$mg2->numFolders = count($mg2->folderIDs);
	$mg2->numItems   = count($mg2->itemIDs);

	// ONLY ONE ITEM OR FOLDER?
	if ($mg2->numItems < 2 && $mg2->numFolders < 2) {
		$mg2->setStatus($mg2->lang['noimagestosort'], 1);
		$display = 'tableview';
		return false;
	}

	// GET SORT FORM ID
	$verify = rawurlencode($mg2->setVerificationToken('saveSorting', 20));
?>
<script src="<?php echo ADDON_FOLDER;?>sorting/js/prototype.js" type="text/javascript"></script>
<script src="<?php echo ADDON_FOLDER;?>sorting/js/scriptaculous.js" type="text/javascript"></script>
<script type="text/javascript">
/* <![CDATA[ */
	var sortQuery      = '<?php printf('&galleryid=%s&verify=%s', substr(GALLERY_ID, 3), $verify);?>';
	var numFolders     =  <?php echo $mg2->numFolders;?>;
	var changedOrderBy = false;
	var sortFolderObj  =
		 {
			constraint: false,
			overlap:    'horizontal',
			scroll:     window,
			onUpdate:   function()
			{
				new Ajax.Updater
				(
					'ajaxresult', '<?php echo ADDON_FOLDER;?>sorting/sorting_save.php',
					{ postBody: Sortable.serialize('sortFolders') + sortQuery }
				);
				resetToPosFolders();
			}
		 }
	var sortItemObj =
		 {
			constraint: false,
			overlap:    'horizontal',
			scroll:     window,
			onUpdate:   function()
			{
				new Ajax.Updater
				(
					'ajaxresult', '<?php echo ADDON_FOLDER;?>sorting/sorting_save.php',
					{ postBody: Sortable.serialize('sortItems') + sortQuery }
				);
				resetToPosItems();
			}
		 }

	function presortActions() {
		document.getElementById('act').value  = "preSorting";
		document.getElementById('dlg').value  = "";
		document.getElementById('dspl').value = "sortview";
		var formObject = document.getElementById('sortform');
		try {
			formObject.action = "<?php echo ADMIN_INDEX;?>" + "#pictures";
		}
		catch (e) {
		}
		formObject.submit();
	}
	function changeItemsDirection() {
		var tempArray = Sortable.sequence('sortItems');
		Sortable.setSequence(
						'sortItems',
						tempArray.slice(0).reverse()
					);
		changedOrderBy = true;
		sortItemObj.onUpdate();
	}
	function isResetSortBy() {
		if (!document.getElementById('itemsSortBy')) return false;

		var resetPos  = false;
		var positions = new Array(0,3,4,6,20,21);
		var sortByIdx = document.getElementById('itemsSortBy').selectedIndex;
		var sortByObj = document.getElementById('itemsSortBy')[sortByIdx];

		for (key in positions) {
			if (positions[key] == sortByObj.value) {
				resetPos = true;
				break;
			}
		}

		return resetPos;
	}
	function resetToPosFolders() {

		if (isResetSortBy())	{
			resetToPosition();
		}
	}
	function resetToPosItems() {

		if (!changedOrderBy) {
			resetToPosition();
		}
		else if (numFolders > 1 && isResetSortBy()) {
			resetToPosition();
		}

		changedOrderBy = false;		
	}
	function resetToPosition() {
		document.getElementById('itemsSortBy').selectedIndex = 2;
		document.getElementById('reloadIcon').style.display  = "none";
		document.getElementById('directItems').style.display = "inline-block";
	}
/* ]]> */
</script>
<!--[if lt IE 7]>
	<style type="text/css">
		ul#sortFolders li {
			width: <?php echo (int)($mg2->thumbMaxWidth + 10);?>px;
		}
	</style>
<![endif]-->
<style type="text/css">
	ul#sortFolders li {
		overflow: hidden;
		height: <?php echo $mg2->thumbMaxHeight + 25;?>px;
		min-width: 35px;
		max-width: <?php echo (int)($mg2->thumbMaxWidth * 1.5);?>px;
		text-align: center;
		white-space: normal;
		float: left;
		list-style-type: none;
		margin: 2px;
		padding: 3px;
		font-size: 9pt;
		color: #3A3A3A;
		cursor: move;
	}
	ul#sortItems li {
		overflow: hidden;
		height: <?php echo $mg2->thumbMaxHeight;?>px;
		min-width: 35px;
		text-align: center;
		float: left;
		list-style-type: none;
		margin: 2px;
		padding: 3px;
		cursor: move;
	}
	ul#sortItems li.red, ul#sortFolders li.red {
		background: #FCA4A4;
	}
	ul#sortItems li.yellow, ul#sortFolders li.yellow {
		background: #EFEE73;
	}
	ul#sortItems li.green, ul#sortFolders li.green {
		background: lime;
	}
</style>
