<?php
//
// SORTING CLASS, IMPLEMENTATION SHOULD BE A STATIC CLASS
// kh_mod 0.4.0 b4, add
class MG2SortingHelper {

	var $mg2;					// parent object reference
	var $presortItemsBy;		// presort by column for drag 'n' drop
	var $directionItems;		// presort direction for drag 'n' drop

	// INITIALIZE SORTING
	function MG2SortingHelper(&$parent) {
		$this->mg2 = &$parent;
		$this->initSortContentBy();
		$this->presortItemIDs();
		$this->presortFolderIDs();
	}

	// PRIVATE: SET SORTING KEY FOR CONTENT
	function initSortContentBy() {

		// IS SET PRESORT MODE
		if (($_POST['action'] === 'preSorting')) {
			$this->presortItemsBy = isset($_POST['itemsSortBy']) ? (int)$_POST['itemsSortBy']:5;
			$this->directionItems = empty($_POST['directItems']) ? 0:16;
		}
		// FIRST CALL OF DRAG 'N' DROP
		else {
			$this->presortItemsBy = $this->mg2->imageSortMode & 15;
			$this->directionItems = $this->mg2->imageSortMode & 16;
		}
	}

	// PRIVATE: PRESORT ITEM IDs
	function presortItemIDs() {

		switch ($this->presortItemsBy) {
			case 13:
				if	(($this->mg2->imageSortMode & 15) !== 13) {
					$this->mg2->setExifDate($this->mg2->itemIDs);
				}
			case 0:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 8:
			case 9:
			case 12:
				$sortMode = $this->presortItemsBy | $this->directionItems;
				$this->mg2->sortIndexDB($this->mg2->itemIDs, 'all_items', $sortMode);
				$_SESSION[GALLERY_ID]['sortItems']['changed'] = false;	// reset items changed
				break;
			case 20:
				$this->mg2->sortByFileDate($this->mg2->itemIDs, $this->directionItems);
				$_SESSION[GALLERY_ID]['sortItems']['changed'] = true;		// pretend items changed
				break;
			case 21:
				shuffle($this->mg2->itemIDs);
				$_SESSION[GALLERY_ID]['sortItems']['changed'] = true;		// pretend items changed
				break;
			default:
				$this->presortItemsBy = 5;
				$_SESSION[GALLERY_ID]['sortItems']['changed'] = true;		// pretend items changed
		}
		$_SESSION[GALLERY_ID]['sortItems']['IDs'] = $this->mg2->itemIDs;
	}

	// PRIVATE: PRESORT FOLDER IDs
	function presortFolderIDs() {

		// FIRST CALL OF DRAG 'N' DROP
		if ($_POST['action'] !== 'preSorting') {
			$this->mg2->sortIndexDB(
								$this->mg2->folderIDs,
								'all_folders',
								$this->mg2->folderSortMode
							);
			$_SESSION[GALLERY_ID]['sortFolders']['IDs']		= $this->mg2->folderIDs;
			$_SESSION[GALLERY_ID]['sortFolders']['changed'] = false;
		}
		// ANY OTHER CALL OF DRAG 'N' DROP
		elseif (!empty($_SESSION[GALLERY_ID]['sortFolders']['IDs'])) {
			$this->mg2->folderIDs = $_SESSION[GALLERY_ID]['sortFolders']['IDs'];
		}
	}

	// SORT NAVIGATION STYLE
	function getNavigationStyle() {

		if ($this->mg2->folderPosition < 0) {
			$sortHead = sprintf('style="padding-top:12px;background-color:#FFCFCF;" title="%s (%s %d)"',
								$this->mg2->lang['nodisplay'],
								$this->mg2->lang['position'],
								$this->mg2->folderPosition
							);
		}
		elseif ($this->mg2->folderPublish > time()) {
			$sortHead = sprintf('style="padding-top:12px;background-color:#FFFF99;" title="%s %s"',
								$this->mg2->lang['notpublished'],
								$this->mg2->time2date($this->mg2->folderPublish)
							);
		}
		else {
			$sortHead = 'style="padding-top:12px;"';
		}

		return $sortHead;
	}

	// SORT NAVIGATION STRING
	function getNavigationString($folderID, $currentPage) {

		// FOLDER PASSWORD SET?
		$folderPwd = (!empty($this->mg2->all_folders[$folderID][8]))?
						 sprintf('<img src="%slock.gif" width="15" height="15" alt="%2$s" title="%2$s" style="margin-left:.5em;vertical-align:text-bottom" />',
							 ADMIN_IMAGES,
							 $this->mg2->lang['thissection']
						 )
						 :
						 '';

		// BUILD BREAD CRUMB NAVIGATION
		return sprintf('%s : <a href="?fID=%d&amp;page=%s&amp;display=sortview" style="font-style:italic;">%s</a> : %s&nbsp;%s%s',
					 $this->mg2->adminNavigation($folderID),
					 $folderID,
					 $currentPage,
					 $this->mg2->lang['sorting'],
					 $this->mg2->numItems,
					 $this->mg2->lang['images'],
					 $folderPwd
				 );
	}

	// GET SUB FOLDERS AS LIST (li) ENTRIES
	function getSubFolderList($folderIDs) {

		// INIT RETURN VALUE
		$folderList = '';

		// GET SUB FOLDERS AS LIST
		foreach($folderIDs as $subfID) {

			// GET FOLDER VALUES
			$folderName	= $this->mg2->all_folders[$subfID][2];
			$folderIcon = $this->mg2->getFolderIcon($subfID);

			// THUMBNAIL DISPLAY TYPE
			if ($this->mg2->all_folders[$subfID][5] < 0) {
				$class = 'red';
			}
			elseif ($this->mg2->all_folders[$subfID][4] > time()) {
				$class = 'yellow';
			}
			else {
				$class = 'green';
			}

			// BUILD FOLDER LIST
			$folderList.= sprintf(
								 '
								 <li id="folder_%d" class="%s">
									 <div style="margin-bottom:.4em;">%6$s</div>
									 <img src="%3$s" %4$s class="%5$s" alt="%6$s" />
								 </li>
								 ',
								 $subfID,
								 $class,
								 $folderIcon['path'],
								 $folderIcon['attrb'],
								 $folderIcon['class'],
								 $this->mg2->getFolderName($subfID, true)
							 );
		}

		return $folderList;
	}

	// GET ITEMS AS LIST (li) ENTRIES
	function getItemList($itemIDs) {

		// INIT RETURN VALUE
		$itemList = '';

		// DISPLAY ALL THUMBNAILS OF FOLDER
		foreach($itemIDs as $itemID) {

			// GET THUMB FILE
			list($thumbID,
				  $thumbFile,
				  $thumbWidth,
				  $thumbHeight) = $this->mg2->getFileIcon($itemID, null, true);

			// THUMBNAIL DISPLAY TYPE
			if ($this->mg2->all_items[$itemID][5] < 0) {
				$class = 'red';
			}
			elseif ($this->mg2->all_items[$itemID][4] > time()) {
				$class = 'yellow';
			}
			else {
				$class = 'green';
			}

			// BUILD ITEM LIST
			$itemList.= sprintf(
								'
								<li id="item_%d" class="%s">
									<img src="%s" width="%d" height="%d" alt="%6$s" title="%6$s" />
								</li>
								',
								$itemID,
								$class,
								$thumbFile,
								$thumbWidth,
								$thumbHeight,
								$this->mg2->htmlchars2entities($this->mg2->getFilePathByID($itemID))
							);
		}

		return $itemList;
	}

	// GET FORM SEND BUTTON
	function getSendButton() {

		return sprintf('<input type="image" src="%sok.gif" alt="%2$s" title="%2$s" class="adminpicbutton" />'."\n",
					ADMIN_IMAGES,
					$this->mg2->lang['setpositions']
				 );
	}

	// GET CANCEL BUTTON
	function getCancelButton($folderID, $page) {

		return sprintf('<a href="%s?dialog=editFolder&amp;fID=%d&amp;page=%s"><img src="%scancel.gif" alt="%5$s" title="%5$s" class="adminpicbutton" /></a>'."\n",
					ADMIN_INDEX,
					$folderID,
					$page,
					ADMIN_IMAGES,
					$this->mg2->lang['cancel']
				 );
	}
}
?>