<?php
//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
//    MG2                                                                       //
//    A PHP/HTML based image gallery script.                                    //
//                                                                              //
//    Copyright 2005 by Thomas Rybak                                            //
//    http://www.minigal.dk                                                     //
//    support@minigal.dk                                                        //
//                                                                              //
//    The script utilises Exif reader v 1.2 (free to use)                       //
//    Exif reader v 1.2                                                         //
//    By Richard James Kendall (richard@richardjameskendall.com)                //
//                                                                              //
//    -----------------                                                         //
//                                                                              //
//    MG2 is free software; you can redistribute it and/or modify               //
//    it under the terms of the GNU General Public License as published by      //
//    the Free Software Foundation; either version 2 of the License, or         //
//    (at your option) any later version.                                       //
//                                                                              //
//    MG2 is distributed in the hope that it will be useful,                    //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of            //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the              //
//    GNU General Public License for more details.                              //
//                                                                              //
//    TO COMPLY WITH THIS LICENSE, DO NOT REMOVE THE LINK TO THE MINIGAL        //
//    WEBSITE FROM YOUR GALLERY FRONT PAGE. THIS IS THE LEAST YOU CAN DO TO     //
//    SUPPORT THE DEVELOPMENT OF MG2!                                           //
//                                                                              //
//    You should have received a copy of the GNU General Public License         //
//    along with this program; if not, you can find it here:                    //
//    http://www.gnu.org/copyleft/gpl.html                                      //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////

// DISPLAY ERRORS BUT HIDE NOTICE, STRICT AND DEPRECATED
error_reporting(E_ALL & ~(E_NOTICE | 2048 | 8192));

// SET PHP ARGUMENT SEPERATOR ON '&AMP'
@ini_set('arg_separator.output','&amp;');

// TO SUPPRESS DateTime E_WARNINGS
if (version_compare(PHP_VERSION, '5.1', '>')) {
	date_default_timezone_set(@date_default_timezone_get());
}

// SESSION START, kh_mod 0.2.0, changed
session_start();

// DEFINE SCRIPT CONSTANTS
define('ROOT_FOLDER',	dirname(__FILE__));
define('GALLERY_ID',		'mg2'. (string)crc32(ROOT_FOLDER));
define('INC_FOLDER',		ROOT_FOLDER .'/includes/');
define('DATA_FOLDER',	ROOT_FOLDER .'/data/');
define('BACKUP_FOLDER',	ROOT_FOLDER .'/data/backup/');
define('LANG_FOLDER',	ROOT_FOLDER .'/lang/');
define('ADMIN_INDEX',	$_SERVER['SCRIPT_NAME']);
define('ADMIN_FOLDER',	'./admin/');
define('ADDON_FOLDER',	'./addons/');
define('ADMIN_IMAGES',	'./admin/images/');
define('MAXLEN_PWD',    4096);

// CHECK SETTING FILE
if (!is_file(DATA_FOLDER .'mg2db_settings.php')) {
	$message = 'Missed file \'mg2db_settings.php\'!';
	include (ADMIN_FOLDER .'fatal_error.php');
	exit();
}

// LOAD CORE MODULES
require(INC_FOLDER .'mg2_functions.php');
require(INC_FOLDER .'mg2admin_functions.php');
require(INC_FOLDER .'mg2admin_treeview.php');
require(INC_FOLDER .'mg2_comments.php');
require(INC_FOLDER .'mg2_counter.php');
require(INC_FOLDER .'mg2_splashes.php');
require(INC_FOLDER .'mg2_keywords.php');
$mg2 = new MG2admin();

////////////////////////////////////////////////////////////////////////////////////////////////////
// ***************************************** SETTINGS ******************************************  //

// DEFAULT SETTINGS
$mg2->imagefolder	  = 'pictures';
$mg2->layoutsetting =  8307;		// 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1
$mg2->extendedset	  = 10460;		// 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0
$mg2->statisticsets =   144;		// settings for stats display
$mg2->inactivetime  =    15;		// max user inactivity in min
$mg2->sqldatabase   =     0;		// use flat file, 1 use MySQL
$mg2->sqlprefix	  = 'mg2_';		// prefix for database tables (currently unused!)
$mg2->charset		  = 'utf-8';	// nessesary for http header and mb_ functions

// LOAD FLAT FILE SETTINGS
require(DATA_FOLDER .'mg2db_settings.php');

// IF SQL DATABASE
if ($mg2->sqldatabase) {

	// CONNECT TO SQL SERVER
	$mg2->getSQLConnect();

	// READ SETTINGS FROM SQL DATABASE
	$mg2->read_sDBSQL();

	// LOAD AND INITIALIZE SQL WRITE
	require_once(INC_FOLDER .'mg2admin_sqlwrite.php');
	$mg2->getInstance('SQLWrite');
}

// IF RESTORE DATA, kh_mod 0.3.0, add; 0.4.1 changed
if (isset($_POST['restBackup'])				&&
	 isset($_POST['use_settings'])			&&
	 isset($_POST['settings'])					&&
	 ((int)$_POST['use_settings'] === 1)	&&
	 (($sTimestamp = (int)substr($_POST['settings'],0,10)) > 1104534000)) // time > 2005-01-01
{
	require_once(INC_FOLDER .'mg2admin_backup.php');
	$Backup = &$mg2->getInstance('MG2Backup');
	$Backup->readBackupSettings($sTimestamp);
}

// SETTINGS CHANGED, kh_mod 0.4.0 b4, changed
elseif (isset($_POST['action']) && ($_POST['action'] === 'writesetup')) {

	// SET GALLERY TITLE
	$mg2->gallerytitle = $mg2->charfix($_POST['gallerytitle']);
	$mg2->gallerytitle = $mg2->cleanHTMLContent($mg2->gallerytitle, array('a','br','img','span','div'));

	// SET GALLERY AND ADMIN LANGUAGE
	$regexp  = '/^[a-z]{2}(_|-)[a-z]{2}$/i';
	$newlang = $_POST['defaultlang'];
	if (preg_match($regexp, $newlang)) {
		$_SESSION[GALLERY_ID]['gallerylang'] = $mg2->defaultlang = $newlang;
	}
}

// ************************************** END OF SETTINGS *************************************  //
//////////////////////////////////////////////////////////////////////////////////////////////////////

// INCLUDE LANGUAGE FILE, kh_mod 0.4.1, changed
if ($langPath = $mg2->checkLanguage($mg2->defaultlang, 'admin')) {
	include sprintf($langPath, 'gallery');
	include sprintf($langPath, 'admin');
}
elseif ($langPath = $mg2->checkLanguage('en_US', 'admin')) {
	$mg2->defaultlang = 'en_US';
	include sprintf($langPath, 'gallery');
	include sprintf($langPath, 'admin');
}

// SET WEB SERVER TO CURRENT CHARSET (LANG FILE)
if ((int)$mg2->extendedset & 64) $mg2->setServerToCharset();

// SET HTTP HEADERS
@header('X-Frame-Options: DENY');
@header('Expires: Mon, 20 Jul 2000 05:00:00 GMT');
@header('Last-Modified: '. gmdate('D, d M Y H:i:s') .' GMT');
@header('Content-Type: text/html; charset='. $mg2->charset);
@header('Content-Script-Type: text/javascript');
@header('Content-Style-Type: text/css');
@header('Cache-Control: no-store, no-cache, must-revalidate');
@header('Cache-Control: post-check=0, pre-check=0', false);
@header('Pragma: no-cache');

// GET PAGE TITLE, changed kh_mod 0.4.1
$pagetitle = $mg2->htmlchars2entities(strip_tags($mg2->gallerytitle), ENT_QUOTES);

// LOGIN SECURITY CHECK, kh_mod 0.1.0pl1, changed
$firstlogin = $mg2->security($pagetitle);

// READ MAIN DATABASE FOR ADMIN, kh_mod 0.4.1, changed
$readMainDB = $mg2->readDB();
if (isset($readMainDB[0]) && ($readMainDB[0] !== false)) {
	define('FolderDataOK', true);
}
if (isset($readMainDB[1]) && ($readMainDB[1] !== false)) {
	define('ItemDataOK', true);
}

// SET FOLDER ID
$folderID = empty($_REQUEST['fID']) ?
				1
				:
				max((int)$_REQUEST['fID'], 1);

// SET FOLDER PAGE
if (!isset($_REQUEST['page'])) {
	$currentPage = 1;
}
elseif ($_REQUEST['page'] === 'all') {
	$currentPage = 'all';
}
else {
	$currentPage = max((int)$_REQUEST['page'], 1);
}

// SET DIALOG WINDOW
$dialog  = isset($_REQUEST['dialog']) ?
			  $_REQUEST['dialog']
			  :
			  '';

// SET DISLPAY MAIN WINDOW
$display = isset($_REQUEST['display']) ?
			  $_REQUEST['display']
			  :
			  'tableview';

// CALLED AS AJAX CONTENT BY COLORBOX, add kh_mod 0.4.2
if (!isset($_GET['cbox']) || !isset($_GET['tab']) || (int)$_GET['tab'] !== 5) {

	// HTML-HEADER, changed kh_mod 0.3.0
	include(ADMIN_FOLDER .'admin_header.php');

//////////////////////////////////////////////////////////////////////////////////////////////////////
// ************************************** START MAIN MENU ***************************************** //

	// CALCULATE ITEMS SIZE, kh_mod 0.3.0, changed
	$totalSize = 0;
	if (is_array($mg2->all_items)) {
		foreach ($mg2->all_items as $item) { $totalSize += (int)$item[12]; }
	}
	$totalSize = $mg2->convertBytes($totalSize);

	// CALCULATE ITEMS NUMBER
	$totalImages = count($mg2->all_items);
	$totalImages.= ' '. (($totalImages === 1)? $mg2->lang['image']:$mg2->lang['images']);

	// CALCULATE FOLDERS NUMBER
	$totalFolders = count($mg2->all_folders); if ($totalFolders > 0) $totalFolders--;
	$totalFolders.= ' '. (($totalFolders === 1)? $mg2->lang['folder']:$mg2->lang['folders']);
	$totalFolders.= ' + '. $mg2->lang['root'];

	// INCLUDE ADMIN MENU
	include(ADMIN_FOLDER .'admin_menu.php');
}
// ************************************* END OF MAIN MENU ************************************** //
///////////////////////////////////////////////////////////////////////////////////////////////////////

// LANGUAGE INSTALLED?
if (empty($mg2->lang)) {
	$mg2->setStatus(sprintf(
							'There isn\'t any language pack installed
							 <a href="%s?display=options&amp;fID=%d&amp;page=%s">...</a>',
							ADMIN_INDEX,
							$folderID,
							$currentPage
						 ), 3);
	$display = '';
}

// DISPLAY ACCRUED MESSAGES FROM SORTING OR LANGUAGE
$mg2->displayStatus();

// FIRST VIEW AFTER LOGIN
if ($firstlogin) {
	$mg2->displayUsedMemory();
	$mg2->checkCurrentSkin();
	$mg2->selectPendingTasks();
	$mg2->isJavaScriptEditor();
	$mg2->setVersionIE();
}
// UPLOAD FILE ERROR
elseif (isset($_GET['loading']) && $_POST['action'] !== 'upload') {
	$max_upload = ini_get('post_max_size');
	$mg2->displayStatus(sprintf($mg2->lang['uploadform_oversized'],
								 preg_replace('/(\d+)M$/','${1} MByte', $max_upload),
								 'post_max_size'
							 ), 2);
}

// 'ACTION' CONTROLLER
if (!empty($_REQUEST['action']))
switch ($_REQUEST['action']) {
	case 'saveSorting':
		if (!$mg2->checkVerificationToken('saveSorting'))		break;
		$mg2->setNewSorting($folderID);
		break;
	case 'updateItem':
		if (!$mg2->checkVerificationToken('updateItem'))		break;
		$updateResult = $mg2->updateItem((int)$_POST['iID']);
		if ($updateResult) {
			$folderID = $updateResult;
			(($nextID = (int)$_POST['nextID']) > 0)?
				$_REQUEST['iID'] = $nextID
				:
				$dialog = '';
		}
		break;
	case 'rotateImage':
		$dialog = 'editItem';
		if (!$mg2->checkVerificationToken('rotate', 'get'))	break;
		$mg2->getMemoryStatus();
		$mg2->rotateImage((int)$_GET['iID']);
		break;
	case 'deleteID':
		if (!$mg2->checkVerificationToken('deleteID'))			break;
		$folderID = $mg2->deleteID($_REQUEST['iID']);
		break;
	case 'upload':
		if (!$mg2->checkVerificationToken('upload'))				break;
		require_once(INC_FOLDER .'mg2admin_import.php');
		$Import  = &$mg2->getInstance('MG2Import');
		$display = $Import->uploadItems($folderID) ?
					  'lastimported'
					  :
					  'tableview';
		break;
	case 'import':
		if (!$mg2->checkVerificationToken('import'))				break;
		if (isset($_POST['reloadDir'])) {
			$display = 'import';
		}
		else {
			$importTofID = (int)$_POST['importTofID'];
			require_once(INC_FOLDER .'mg2admin_import.php');
			$Import  = &$mg2->getInstance('MG2Import');
			$display = $Import->importStart($importTofID) ?
						  'lastimported'
						  :
						  'tableview';
		}
		break;
	case 'buildNewFolder':
		if (!$mg2->checkVerificationToken('buildNewFolder'))	break;
		$folderID = ($result = $mg2->buildNewFolder($folderID))?
						$result
						:
						1;
		break;
	case 'updateFolder':
		if (!$mg2->checkVerificationToken('updateFolder'))		break;
		if ($result = $mg2->updatefolder((int)$_POST['fID'])) {
			$folderID = $result;
		}
		break;
	case 'updateComment':
		if (!$mg2->checkVerificationToken('updateComment'))	break;
		$Comments	= &$mg2->getInstance('MG2Comments');
		$commUpdIDs	= $Comments->updateComment(
											(int)$_POST['iID'],
											(int)$_POST['commentID']
										 );
		// BACK TO 'EDIT COMMENT' DIALOG
		if ($commUpdIDs === false) {
			$_GET['iID']			= (int)$_POST['iID'];
			$_GET['editComment']	= (int)$_POST['commentID'];
		}
		break;
	case 'adminComments':
		if (!$mg2->checkVerificationToken('adminComments'))	break;
		$itemID   = (int)$_REQUEST['iID'];
		$Comments = &$mg2->getInstance('MG2Comments');
		$Comments->adminCommentAction($itemID);
		break;
	case 'writesetup':
		if (!$mg2->checkVerificationToken('settings'))			break;
		$mg2->prepareSetup();
		break;
	case 'dbswitch':	// database switch
		$db = substr($_POST['database'], 0, 11);
		$mg2->switchDatabase($db);
		break;
	case 'makeBackup':
		if (!$mg2->checkVerificationToken('makeBackup'))		break;
		require_once(INC_FOLDER .'mg2admin_backup.php');
		$Backup = &$mg2->getInstance('MG2Backup');
		isset($_POST['backupData']) ?
			$Backup->backup_DB($_POST['backupData'])
			:
			$Backup->backup_DB(array());
		break;
	case 'useBackup':
		if (!$mg2->checkVerificationToken('useBackup'))			break;
		require_once(INC_FOLDER .'mg2admin_backup.php');
		$Backup = &$mg2->getInstance('MG2Backup');
		if (isset($_POST['restBackup']))
			$Backup->restoreBackup();
		elseif (isset($_POST['delBackup']))
			$Backup->deleteBackup();
		break;
	case 'convert':	// do convert data
		include(INC_FOLDER .'mg2admin_converter.php');
		$Converter = &$mg2->getInstance('MG2AdminConverter');
		if ($_POST['item'] === 'clickDB') {
			$Converter->updateClickData();
		}
		elseif ($_POST['item'] === 'iDB') {
			$Converter->updateItemData();
		}
		elseif ($_POST['item'] === 'fDB') {
			$Converter->updateFolderData();
		}
		elseif ($_POST['item'] === 'cDB') {
			$Converter->updateCommentData();
		}
		break;
	case 'openTasks':
		if (!$mg2->checkVerificationToken('openTasks'))			break;
		require_once(INC_FOLDER .'mg2admin_itemprocess.php');
		$ItemProcess = &$mg2->getInstance('MG2ItemProcess');
		if (isset($_POST['rebuild_x']) && isset($_POST['tasks'])) {
			if ($_POST['tasks'] === 'do')  $ItemProcess->doItemProcessList();
			if ($_POST['tasks'] === 'del') $ItemProcess->delAllProcessTasks();
		}
		else {
			$ItemProcess->delItemProcessList();
		}
		break;
	case 'rebuildItem':
		if (!$mg2->checkVerificationToken('rebuildItem'))		break;
		$rebuildID = (int)$_POST['rebuildID'];
		require_once(INC_FOLDER .'mg2admin_rebuild.php');
		$Rebuild	  = &$mg2->getInstance('MG2Rebuild');
		if ($Rebuild->rebuildItemStart($rebuildID)) {
			$folderID = max((int)$mg2->all_items[$rebuildID][1], 1);
		}
		break;
	case 'rebuildFolder':
		if (!$mg2->checkVerificationToken('rebuildFolder'))	break;
		$rebuildID = (int)$_POST['rebuildID'];
		require_once(INC_FOLDER .'mg2admin_rebuild.php');
		$Rebuild	  = &$mg2->getInstance('MG2Rebuild');
		if ($Rebuild->rebuildFolderStart($rebuildID)) {
			$folderID = $rebuildID;
		}
		break;
	case 'rebuildBooked':
		if (!$mg2->checkVerificationToken('rebuildBooked'))	break;
		require_once(INC_FOLDER .'mg2admin_rebuild.php');
		$Rebuild = &$mg2->getInstance('MG2Rebuild');
		$Rebuild->rebuildBookedStart();
		break;
	case 'rebuildKeyword':
		if (!$mg2->checkVerificationToken('rebuildKeyword'))	break;
		$rebuildID = (int)$_POST['rebuildID'];
		require_once(INC_FOLDER .'mg2admin_rebuild.php');
		$Rebuild	  = &$mg2->getInstance('MG2Rebuild');
		$Rebuild->rebuildKeywordStart($rebuildID);
		break;
	case 'rebuildImported':
		if (!$mg2->checkVerificationToken('rebuildImported'))	break;
		require_once(INC_FOLDER .'mg2admin_rebuild.php');
		$Rebuild = &$mg2->getInstance('MG2Rebuild');
		$Rebuild->rebuildImportedStart();
		break;
	case 'removeItemLink':
		$display	= 'bookmarked';
		if ($_GET['iID'] === 'all') {
			$mg2->removeAllBookmarks();
		}
		elseif ($removeID = (int)$_GET['iID']) {
			$mg2->removeItemBookmark($removeID);
		}
		break;
	case 'removeItemForm':
		$display	= 'bookmarked';
		if (!$mg2->checkVerificationToken('removeItemForm'))	break;
		$mg2->removeSelectedBookmarks();
		break;
	case 'buildNewKeyword':
		$display  = 'keywords';
		if (!$mg2->checkVerificationToken('buildNewKeyword'))	break;
		$Keywords = &$mg2->getInstance('MG2Keywords');
		$_REQUEST['keyID'] = $Keywords->buildNewKeyword();
		break;
	case 'updateKeyword':
		$display  = 'keywords';
		if (!$mg2->checkVerificationToken('updateKeyword'))	break;
		$Keywords = &$mg2->getInstance('MG2Keywords');
		$keyID    = (int)$_POST['keyID'];
		$Keywords->updateKeyword($keyID);
		break;
	case 'deleteKeywordForm':
		if (!$mg2->checkVerificationToken('deleteKeywordForm')) break;
		if (isset($_POST['delUnusedFiles'])) {
			$Keywords = &$mg2->getInstance('MG2Keywords');
			$Keywords->deleteUnusedKeywords();
		}
		elseif (isset($_POST['delAllFiles'])) {
			$Keywords = &$mg2->getInstance('MG2Keywords');
			$Keywords->deleteAllKeywords();
		}
		break;
	case 'deleteKeywordLink':
		$display  = 'keywords';
		if (!isset($_GET['keyID'])) break;
		$Keywords = &$mg2->getInstance('MG2Keywords');
		if ($_GET['keyID'] === 'all') {
			$Keywords->deleteAllKeywords();
		}
		else {
			$Keywords->deleteKeyword((int)$_GET['keyID']);
		}
}

// DELETE FOLDER, ACTION
if (isset($_POST['delFolder']) && $mg2->checkVerificationToken('delFolder')) {
	$folderID = $mg2->delFolder((int)$_POST['delFolder']);
}
// DELETE FILES, ACTION, kh_mod 0.4.0 rc1, changed
if (!empty($_POST['delFiles']) && $mg2->checkVerificationToken('tableview')) {
	$mg2->deleteFiles();
}
// MOVE ITEMS, ACTION, kh_mod 0.4.0 rc1, changed
if (!empty($_POST['moveItems']) && $mg2->checkVerificationToken('tableview')) {
	$mg2->moveItems();
}
// ADD MULTIPLE KEYWORDS, ACTION, kh_mod 0.4.3, add, for Lukasz
if (!empty($_POST['addKeywords']) && $mg2->checkVerificationToken('tableview')) {
	$Keywords = &$mg2->getInstance('MG2Keywords');
	$Keywords->addKeywordsToItems();
}
// REMOVE MULTIPLE KEYWORDS, ACTION, kh_mod 0.4.3, add
if (!empty($_POST['remKeywords']) && $mg2->checkVerificationToken('tableview')) {
	$Keywords = &$mg2->getInstance('MG2Keywords');
	$Keywords->remKeywordsToItems();
}

//
// END OF 'ACTION' CONTROLLER
//

//
// DISPLAY DIALOGS
//

// DISPLAY PENDING REBUILD TASKS DIALOG
if ($numTasks = count($mg2->getItemProcessList())) {
	$dialog = 'openTasks';
}

// 'EDIT COMMENT' DIALOG, kh_mod 0.1.0, add; 0.4.1 changed
elseif (isset($_GET['editComment'])) {
	$Comments	 = &$mg2->getInstance('MG2Comments');
	$editComment = $Comments->editComment(
											(int)$_GET['iID'],
											(int)$_GET['editComment']
									  );
	// IF 'EDIT COMMENT' DIALOG OK, THEN DON'T DISPLAY 'TABLEVIEW'
	if ($editComment === true) {
		$dialog  = '';
		$display = '';
	}
	// BACK TO 'EDIT ITEM' DIALOG
	else {
		$dialog = 'editItem';
	}
}

// 'DELETE COMMENT' DIALOG, kh_mod 0.1.0, add; 0.4.1 changed
elseif (isset($_REQUEST['askDelComment'])) {
	$Comments = &$mg2->getInstance('MG2Comments');
	$askDelOK = $Comments->askDelComment(
										(int)$_REQUEST['iID'],
										(int)$_REQUEST['askDelComment']
								  );
	// IF 'ASK DELETE COMMENT' DIALOG OK, THEN EXIT
	if ($askDelOK === true) {
		$dialog  = '';
		$display = '';
	}
}

// 'DIALOG' CONTROLLER
switch ($dialog) {
	case '': break;
	case 'openTasks':
		$verify  = $mg2->setVerificationToken('openTasks');
		$display = '';
		include(ADMIN_FOLDER .'admin_opentasks.php');	
		break;
	case 'editNewFolder':
		$ftype = isset($_GET['ftype']) ? (int)$_GET['ftype']:0;
		if ($ftype === 9) {
			$display  = '';
			$Keywords = &$mg2->getInstance('MG2Keywords');
			$Keywords->editNewKeyword();
			break;
		}
		if ($ftype === 1) {
			$fIDstoRoot = $mg2->getFolderBranchToRoot($folderID);
			foreach ($fIDstoRoot as $id) {
				if ((int)$mg2->all_folders[$id][11] === 1) {
					$mg2->displayStatus($mg2->lang['sublinkfolder'], 1);
					break 2;	// link sub folders aren't allowed
				}				// into other link folders
			}
		}
		$display = '';
		$mg2->editNewFolder($folderID, $currentPage, $ftype);
		break;
	case 'editFolder':
		$folderID = $mg2->editFolder($folderID, $currentPage);
		break;
	case 'deleteFolder':
		$deleteID = (int)$_GET['delID'];
		$folderID = empty($_GET['fID']) ?
						$deleteID
						:
						max((int)$_GET['fID'], 1);
		$mg2->askDelFolder($deleteID, $folderID, $currentPage);
		break;
	case 'editItem':
		if (!isset($commUpdIDs)) $commUpdIDs = -1;
		$callItem = $mg2->editItem((int)$_REQUEST['iID'], $commUpdIDs, $display);
		if (is_array($callItem)) {
			list($folderID, $currentPage) = $callItem;
		}
		break;
	case 'deleteItem':
		$folderID = $mg2->askDeleteID((int)$_GET['iID'], $currentPage, $display);
		break;
	case 'editKeyword':
		$display  = 'keywords';
		$Keywords = &$mg2->getInstance('MG2Keywords');
		$Keywords->editKeyword((int)$_REQUEST['keyID']);
		break;
	case 'rebuild':
		require_once(INC_FOLDER .'mg2admin_rebuild.php');
		$Rebuild = &$mg2->getInstance('MG2Rebuild');
		if (!empty($_GET['iID'])) {
			$folderID = $Rebuild->askRebuildItem((int)$_GET['iID'], $currentPage);
		}
		elseif (!empty($_GET['fID'])) {
			$folderID = $Rebuild->askRebuildFolder((int)$_GET['fID'], $currentPage);
		}
		elseif (!empty($_GET['keyID'])) {
			$Rebuild->askRebuildKeyword((int)$_GET['keyID']);
			$display = 'keywords';
		}
		elseif ($display === 'bookmarked') {
			$Rebuild->askRebuildBooked();
		}
		elseif ($display === 'lastimported') {
			$Rebuild->askRebuildImported();
		}
}
// END OF 'DIALOG' CONTROLLER

// DISPLAY MAIN WINDOW
switch ($display) {
	case 'system'       : $mg2->displaySystem(); 									break;
	case 'bookmarked'   : $mg2->displayBookmarked();								break;
	case 'keywords'     : $mg2->displayKeywords();									break;
	case 'lastimported' : $mg2->displayLastImported();								break;
	case 'sortview'     : $mg2->displaySortview($folderID, $currentPage);	break;
	case 'upload'       : $mg2->displayUpload($folderID, $currentPage);		break;
	case 'import'       : $mg2->displayImport($folderID, $currentPage);		break;
	case 'options'      : $mg2->displayOptions($folderID, $currentPage);		break;
	case 'tableview'    : $mg2->displayTableview($folderID, $currentPage);
}

// DISPLAY FOOTER
include ADMIN_FOLDER .'admin_credits.php';
?>