<?php if (!isset($contentType['image'])) {

		// GET DEFAULT ICON
		list($defaultID, $defaultIcon, $defaultWidth, $defaultHeight) = ($thumbID === 0)?
			array(0, $thumbFile, $thumbWidth, $thumbHeight)
			:
			$this->getFileIcon(0, $contentType);

		// GET VALUES FOR THE DEFAULT OPTION TAG
		$valuesOptionTags   = array();
		$valuesOptionTags[] = array('',									// css options
											 0,									// icon id
											 $defaultIcon,						// icon path
											 $defaultWidth,					// icon width
											 $defaultHeight,					// icon height
											 $defaultIcon,						// tooltip
											 '',									// selected attribute
											 $this->lang['defaulticon']	// option text
									 );

		// GET SPLASH DATA
		$Splashes = &$this->getInstance('MG2Splashes');
		list(	$thumbID,
				$splashID,		
				$backgrID,
				$spColor,
				$bgColor) = $Splashes->getSplashRecord($editID);

		// SET CURRENT THUMB, BG AND SPLASH PICTURE ON TOP
		$curr_time = time();
		if (isset($this->all_items[$thumbID])) {
			$this->all_items[$thumbID][15] = $curr_time;
		}
		if (isset($this->all_items[$splashID])) {
			$this->all_items[$splashID][15] = $curr_time - 1;
		}
		if (isset($this->all_items[$backgrID])) {
			$this->all_items[$backgrID][15] = $curr_time - 2;
		}

		// IF BOOKMARKED ICON TYPES 'SVG'
		$svgFlag = $this->contentCodeTable('SVG');

		// SELECT ALL BOOKMARKED IMAGES AND SORT BY DATE
		foreach($this->selectIndexDB(true, 'all_items', 15, 31) as $markedID) {
			$markedRC = $this->all_items[$markedID];

			// GET IMAGE AND ICON FILE PATH
			$filepath = $this->getFilePathByName($markedRC[6], $markedRC[7]);
			$iconpath = (($markedRC[16] & $svgFlag) === $svgFlag)?
							$filepath
							:
							$this->getFilePathByName($markedRC[6], $markedRC[7], 'thumb');

			// IMAGE LOCKED?
			if ($markedRC[5] < 0) {
				$marked	= 'background-color:#FF9999;';
				$tooltip	= sprintf('%s: %s', $this->lang['nodisplay'], $filepath);
			}
			// IMAGE NOT YET PUBLISHED?
			elseif ($markedRC[4] > time()) {
				$marked	= 'background-color:#FFFF99;';
				$tooltip	= sprintf('%s %s; %s',
									$this->lang['notpublished'],
									$this->time2date($markedRC[4]),
									$filepath
							  );
			}
			else {
				$marked	= '';
				$tooltip	= $filepath;
			}

			// GET VALUES FOR OPTION TAGS
			$valuesOptionTags[] = array($marked,
												$markedID,
												$iconpath,
												$markedRC[10],
												$markedRC[11],
												$tooltip,
												$thumbID === $markedID ? 'selected="selected"':'',
												$this->mb_shorten($markedRC[6], 20)
										 );
		}
		// DIVISOR FOR FLASH MINI THUMBS
		$divisor = 5;
		include (ADMIN_FOLDER .'js/jsSplashSelect.php');
	}
?>
<form name="editfolder" action="<?php echo ADMIN_INDEX;?>" onsubmit="this.isJavaScript.value='on'" method="post">
<input type="hidden" name="action" value="updateItem" />
<input type="hidden" name="dialog" value="<?php echo $dialog;?>" />
<input type="hidden" name="iID" value="<?php echo $editID;?>" />
<input type="hidden" name="nextID" value="<?php echo $nextID;?>" />
<input type="hidden" name="page" value="<?php echo $currentPage;?>" />
<input type="hidden" name="display" value="<?php echo $display;?>" />
<input type="hidden" name="verify" value="<?php echo $this->setVerificationToken('updateItem');?>" />
<input type="hidden" name="isJavaScript" value="off" />
<input type="hidden" name="mimetype" value="<?php echo defined('JS_EDITOR') ? 'html':'plain';?>" />
<table class="table_actions" cellpadding="0" cellspacing="0" border="0">
<tr>
	<td class="headline" colspan="2" width="310" style="padding:.7em .4em;font-size:8.5pt;border-right:0">
<?php
	$edititem = 'editimage';
	if		 (isset($contentType['video']))	$edititem = 'editvideo';
	elseif (isset($contentType['audio']))	$edititem = 'editaudio';
	echo $this->lang[$edititem];
?>
	</td>
	<td class="headline" colspan="2">
		<table class="minithumb" cellspacing="0" cellpadding="0">
			<tr>
				<td>&nbsp;<?php $this->output('nav_first');?>&nbsp;</td>
				<td>&nbsp;<?php $this->output('nav_prev');?>&nbsp;</td>
				<td>&nbsp;<?php $this->output('nav_this');?>&nbsp;</td>
				<td>&nbsp;<?php $this->output('nav_next');?>&nbsp;</td>
				<td>&nbsp;<?php $this->output('nav_last');?>&nbsp;</td>
			</tr>
		</table>
	</td>
</tr>
<tr valign="top">
	<td class="td_actions_right" width="180"><?php echo $this->lang['itemicon'];?></td>
	<td class="td_actions_right" width="140"><?php echo $this->lang['filename'];?></td>
	<td class="td_actions_right">
		<input type="text" name="filename" value="<?php echo $filename;?>" size="80" class="admintext" />
	</td>
	<td class="td_actions" rowspan="7">
		<div style="margin:0 .3em;width:208px;">
			<div style="margin:0 0 .3em .3em;">
<?php
			printf('%s<div>%s%s</div>',
				"\t\t\t\t",
				$this->lang['keywords'],
				($this->layoutsetting & 1<<6)? '':'<sup>*</sup>'
			);
?> 
				<div style="white-space:normal;"><?php echo $this->lang['comma_separeted'];?></div>
			</div>
			<textarea class="keywords" name="keywords" rows="16" cols="24"><?php echo $keyString;?></textarea>
<?php
	// KEYWORDS SWITCHED OFF (GLOBAL)
	printf('<div class="td_actions_noborder" style="background-color:%s;">%s</div>',
		($this->layoutsetting & 1<<6)? 'transparent':'#FFCFCF',
		($this->layoutsetting & 1<<6)?
			''
			:
			sprintf('<div style="%s%s%s"><sup>*</sup><a href="%s?display=options&amp;fID=%d&amp;page=%s#layout">%s</a>: %s</div>',
				'margin-left: .5em;',
				'text-indent:-.5em;',
				'white-space:normal;',
				ADMIN_INDEX,
				$folderID,
				$currentPage,
				$this->lang['setup'],
				$this->lang['global_switchoff']
			)
	);
?>
		</div>
	</td>
</tr>
<tr>
	<td rowspan="5" class="td_actions_right" style="vertical-align:middle;" width="170" align="center">
		<a href="<?php echo $this->getGalleryLink(array('iID'=>$editID,'user'=>GALLERY_ID));?>" target="_blank">
		<img id="fileicon" src="<?php echo $thumbFile;?>" <?php echo $thumbSize;?> alt="<?php echo $this->lang['viewimage'];?>" title="<?php echo $this->lang['viewimage'];?>" class="thumb" /></a>
		<div style="margin:1em 0 4em 0;">
<?php
	// IF IMAGE CONTENT
	if (isset($contentType['image']) && !isset($contentType['svg'])) {
		// IMAGE ROTATE BUTTONS (LEFT/RIGHT)
		$verify = rawurlencode($this->setVerificationToken('rotate'));
		$button = '<a href="%s?action=rotateImage&amp;direction=%s&amp;iID=%d&amp;display=%s&amp;verify=%s">';
		$button.= '<img src="%s%s" width="24" height="24" alt="%8$s" title="%8$s" class="adminpicbutton" />';
		$button.= '</a>';
		printf("\n". $button,
			ADMIN_INDEX,
			'left',
			$editID,
			$display,
			$verify,
			ADMIN_IMAGES,
			'rotateleft.gif',
			$this->lang['rotateleft']
		);
		printf("\n". $button,
			ADMIN_INDEX,
			'right',
			$editID,
			$display,
			$verify,
			ADMIN_IMAGES,
			'rotateright.gif',
			$this->lang['rotateright']
		);
	}
?> 
		</div>
	</td>
	<td class="td_actions_right">
<?php
		printf('<span title="%s">%s</span>', $this->lang['negative_pos'],	$this->lang['position']);
?> 
	</td>
	<td class="td_actions_right">
		<input type="text" name="position" value="<?php echo $position;?>" size="26" class="admintext" />
<?php
	// BUTTON FOR ITEM AND FOLDER SORTING
	if ($display === 'tableview') {
		printf('
			<img src="%ssorting.gif" width="17" height="15" alt="%2$s" title="%2$s" class="adminpicbutton" onclick="callSorting(%3$d, %4$d)" />
			',
			ADMIN_IMAGES,
			$this->lang['sorting'],
			$folderID,
			$currentPage
		);
	}
?> 
	</td>
</tr>
<tr>
	<td class="td_actions_right" width="100"><?php echo $this->lang['publish'];?></td>
	<td class="td_actions_right">
		<input type="text" name="publish" id="publish" value="<?php echo $publish;?>" size="26" class="admintext" />
<?php
		if (is_a($this->Calendar, 'MG2Calendar')) {
			echo '&nbsp;'.
			$this->Calendar->_make_calendar(
				// calendar options go here; see the documentation and/or calendar-setup.js
				array('date'			=> $publish,							// CALENDAR START DATE
						'ifFormat'		=> $this->dateformat .', %H:%M',	// CALENDAR FORMAT
						'inputField'	=> 'publish')							// INPUT FIELD ID
			);
		}
?>
	</td>
</tr>
<tr>
	<td class="td_actions_right"><?php echo $this->lang['title'];?></td>
	<td class="td_actions_right">
		<input type="text" name="title" value="<?php echo $title;?>" size="80" class="admintext" />
	</td>
</tr>
<tr>
<?php
	// DESCRIPTION SWITCHED OFF (GLOBAL)
	printf(
		'<td class="td_actions_right" style="white-space:normal;background-color:%s;">
			<span title="'. sprintf($this->lang['maxlen_characters'],7167) .'">%s</span>%s
		</td>',
		($this->layoutsetting & 32)?	'transparent':'#FFCFCF',
		$this->lang['description'],
		($this->layoutsetting & 32)?
			''
			:
			sprintf('*<div style="%s%s"><sup>*</sup><a href="%s?display=options&amp;fID=%d&amp;page=%s#layout">%s</a>: %s</div>',
				'margin:1.3em .5em;',
				'text-indent:-.5em;',
				ADMIN_INDEX,
				$folderID,
				$currentPage,
				$this->lang['setup'],
				$this->lang['global_switchoff']
			)
	);
?> 
	<td class="td_actions_right">
		<div class="wysiwyg_editor" style="padding:3px;width:508px;">
			<textarea id="editor" name="description" cols="78" rows="10" class="admindropdown" style="padding:2px;width:500px;height:200px;"><?php echo $description;?></textarea>
		</div>
	</td>
</tr>
<tr>
	<td class="td_actions_right">
<?php
	printf('<span title="%s">%s</span>',
		$this->lang['displayinto_exif'],
		(isset($contentType['flash'])) ? $this->lang['artist']:$this->lang['photographer']
	);
?>	
	</td>
	<td class="td_actions_right">
		<input type="text" name="photographer" value="<?php echo $photographer;?>" size="80" class="admintext" />
	</td>
</tr>
<?php
// START WITH FLASH OPTIONS
if (!isset($contentType['image'])) {
?>
<tr>
	<td class="td_actions" align="center">
		<select name="image4icon" size="1" class="admindropdown" onfocus="initIcon('fileicon')" onchange="setIcon(this)">
<?php
		$optionTag = '<option style="padding:1px 12px 1px 3px;%s" onmouseover="changeIcon(this)" onmouseout="restoreIcon()" value="%d::%s::%d::%d" title="%s" %s>%s</option>';
		foreach ($valuesOptionTags as $valuesOptionTag) {
			vprintf("\n". $optionTag, $valuesOptionTag);
		}
?> 
		</select>
	</td>
	<td class="td_actions"><?php echo $this->lang['canvassize'];?></td>
	<td class="td_actions">
		<?php echo $this->lang['width'];?>:  <input name="canvas_width"  type="text" size="12" value="<?php echo (int)$itemRC[8];?>" />&nbsp;px
		&nbsp;&nbsp;
		<?php echo $this->lang['height'];?>: <input name="canvas_height" type="text" size="12" value="<?php echo (int)$itemRC[9];?>" />&nbsp;px
	</td>
</tr>
<tr>
	<td class="td_actions" colspan="4">
	<table cellpadding="0" cellspacing="0">
	<tr>
		<td class="headline" style="border-right:0" colspan="5"><?php echo $this->lang['flash_options'];?></td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td class="headline" width="90">&nbsp;</td>
		<td class="headline" width="60"  align="center"><?php echo $this->lang['selection'];?></td>
		<td class="headline" width="110" align="center"><?php echo $this->lang['bookmarked_images'];?></td>
		<td class="headline" width="60"  align="center"><?php echo $this->lang['selection'];?></td>
		<td class="headline" width="40"  align="center" title="<?php echo $this->lang['color_syntax'];?>"><?php echo $this->lang['color'];?></td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td class="setup_right"><?php echo $this->lang['splash_image'];?></td>
		<td class="setup_right" align="center">
<?php
		// SPLASH SETTINGS, kh_mod 0.4.0 b3 changed
		if (isset($this->all_items[$splashID])						&&
			 ($splashURL = $this->getFilePathByID($splashID))	&&
			 is_file($splashURL))
		{
			$icon_width  = $this->all_items[$splashID][10];
			$icon_height = $this->all_items[$splashID][11];
		}
		else
		{
			$splashURL   = ADMIN_IMAGES .'1x1.gif';
			$icon_width  = 1;
			$icon_height = 1;
		}
		printf('<img id="splashID" src="%s" width="%d" height="%d" alt="" onmouseover="initTip(\'splashID\', %4$d, %5$d)" onmouseout="UnTip()" />',
			$splashURL,
			max(round($icon_width/$divisor,  0), 5),
			max(round($icon_height/$divisor, 0), 5),
			$icon_width,
			$icon_height
		);
?>	
		</td>
		<td class="setup_right">
		<div style="margin: 0 auto 0 auto;">
		<select name="image4splash" size="1" class="admindropdown" onfocus="initIcon('splashID')" onchange="setIcon(this)">
<?php
		// DISPLAY SPLASH IMAGE SELECT BOX
		$valuesOptionTags[0] = array('', 0, ADMIN_IMAGES .'1x1.gif', 1, 1, '', '', ' -- '. $this->lang['noimage'] .' -- ');
		foreach ($valuesOptionTags as $valuesOptionTag) {
			$valuesOptionTag[6] = ($splashID === $valuesOptionTag[1])? 'selected="selected"':'';
			vprintf("\n". $optionTag, $valuesOptionTag);
		}
?>
		</select>
		</div>
		</td>
		<td class="setup_right" align="center">
<?php
			printf('<div id="splashColorPad" style="width:%dpx;height:%dpx;background-color:%s;">&nbsp;</div>',
				max(round($this->thumbMaxWidth/$divisor,  0), 5),
				max(round($this->thumbMaxHeight/$divisor, 0), 5),
				$spColor
			);
?> 
		</td>
		<td class="setup_right">
			<input type="text" id="spColor" name="spColor" value="<?php echo $spColor;?>" class="admintext" />
		</td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td class="setup"><?php echo $this->lang['background'];?></td>
		<td class="setup" align="center">
<?php
		// BACKGROUND SETTINGS
		if (isset($this->all_items[$backgrID])) {
			$flwp_bgURL  = $this->getFilePathByID($backgrID);
			$icon_width  = $this->all_items[$backgrID][10];
			$icon_height = $this->all_items[$backgrID][11];
		}
		else {
			$flwp_bgURL  = ADMIN_IMAGES .'1x1.gif';
			$icon_width  = 1;
			$icon_height = 1;
		}
		printf('<img id="backgrID" src="%s" width="%d" height="%d" alt="" onmouseover="initTip(\'backgrID\', %4$d, %5$d)" onmouseout="UnTip()" />',
			$flwp_bgURL,
			max(round($icon_width/$divisor,  0), 5),
			max(round($icon_height/$divisor, 0), 5),
			$icon_width,
			$icon_height
		);
?>			
		</td>
		<td class="setup">
		<div style="margin: 0 auto 0 auto;">
		<select name="image4bg" size="1" class="admindropdown" onfocus="initIcon('backgrID')" onchange="setIcon(this)">
<?php
		// DISPLAY BACKGROUND SELECT BOX
		foreach ($valuesOptionTags as $valuesOptionTag) {
			if ($backgrID === $valuesOptionTag[1]) {
				$valuesOptionTag[6] = 'selected="selected"';
			}
			elseif ($this->getContentType($valuesOptionTag[1], 'SVG')) {
				$valuesOptionTag[2] = ADMIN_IMAGES .'1x1.gif';
				$valuesOptionTag[3] = 1;
				$valuesOptionTag[4] = 1;
				$valuesOptionTag[5] = 'SVG background isn\'t supported!';
				$valuesOptionTag[6] = 'disabled="disabled"';
			}
			else {
				$valuesOptionTag[6] = '';
			}
			vprintf("\n". $optionTag, $valuesOptionTag);
		}
?>	
		</select>
		</div>
		</td>
		<td class="setup" align="center">
<?php
			printf('<div id="bgColorPad" style="width:%dpx;height:%dpx;background-color:%s;">&nbsp;</div>',
				max((int)round($this->thumbMaxWidth/$divisor,  0), 5),
				max((int)round($this->thumbMaxHeight/$divisor, 0), 5),
				$bgColor
			);
?> 
		</td>
		<td class="setup">
			<input type="text" id="bgColor" name="bgColor" value="<?php echo $bgColor;?>" class="admintext" />
		</td>
		<td>&nbsp;</td>
	</tr>
	</table>
	<script type="text/javascript" src="<?php echo ADMIN_FOLDER;?>js/jscolor/jscolor.js"></script>
	<script type="text/javascript">
	/* <![CDATA[ */
		jscolor.dir = '<?php echo ADMIN_FOLDER .'js/jscolor/';?>';
		new jscolor.color(document.getElementById('spColor'), { styleElement:'splashColorPad' });
		new jscolor.color(document.getElementById('bgColor'), { styleElement:'bgColorPad' });
	/* ]]> */
	</script>
	</td>
</tr>
<?php
// END OF FLASHOPTIONS
} else {
?>
<tr>
	<td class="td_actions" align="center">
<?php
		printf('<input type="checkbox" name="selected" id="selected" value="ok" style="vertical-align:middle;"%s /> ',
			$selected
		);
		printf('<label for="selected" class="bookmark" style="vertical-align:middle;" title="%s"> %s</label>',
			$this->lang['bookmark_title'],
			$this->lang['bookmark']
		);
?>
	</td>
	<td class="td_actions" style="white-space:normal;">
		<?php echo $this->lang['setasthumb'];?>
	</td>
	<td class="td_actions">
		<select size="1" name="setthumb" class="admindropdown">
<?php
		printf('
			<option style="padding:1px 12px 1px 3px;" title="" value="">-- %s --</option>
			'.
			"\n",
			$this->lang['nofolderselected']
		);

		$Treeview = &$this->getInstance('MG2Treeview');
		echo $Treeview->getFolderOptionTags($folderID, 'editItem');
?> 
		</select>
	</td>
</tr>
<?php } ?>
<tr>
	<td class="td_actions" colspan="4" align="center">
<?php
	// CANCEL BUTTON
	printf("\n".'<a href="%s?fID=%d&amp;page=%s&amp;display=%s"><img src="%5$scancel.gif" width="24" height="24" alt="%6$s" title="%6$s" class="adminpicbutton" /></a>	',
		ADMIN_INDEX,
		$folderID,
		$currentPage,
		$display,
		ADMIN_IMAGES,
		$this->lang['cancel']
	);
	// OK BUTTON
	printf("\n".'<input type="image" src="%sok.gif" class="adminpicbutton" alt="%2$s" title="%2$s" />',
		ADMIN_IMAGES,
		$this->lang['ok']
	);
?> 
	</td>
</tr>
</table>
</form>
