<?php
	// HIDE ERRORS
	error_reporting(0);

	// ARE SET INPUT VALUES
	if (!isset($_GET['f']))	exit();
	if (!isset($_GET['s']))	exit();

	// SESSION START
	session_start();

	// DEFINE SCRIPT CONSTANTS
	define('ROOT_FOLDER',	dirname(dirname(__FILE__)));
	define('GALLERY_ID',		'mg2'. (string)crc32(ROOT_FOLDER));
	define('INC_FOLDER',		ROOT_FOLDER .'/includes/');
	define('DATA_FOLDER',	ROOT_FOLDER .'/data/');
	define('ADMIN_IMAGES',	ROOT_FOLDER .'/admin/images/');

	// CHECK SETTING FILE
	if (!is_file(DATA_FOLDER .'mg2db_settings.php')) exit();

	// LOAD MODULES
	require(INC_FOLDER .'mg2_functions.php');
	require(INC_FOLDER .'mg2admin_functions.php');
	require(INC_FOLDER .'mg2_exif.php');
	$mg2 = new MG2admin();

	// DEFAULT SETTINGS
	$mg2->imagefolder	  = 'pictures';
	$mg2->inactivetime  = 15;		// max user inactivity in min
	$mg2->sqldatabase   =  0;		// use flat file, 1 use MySQL

	// LOAD FLAT FILE SETTINGS
	require(DATA_FOLDER .'mg2db_settings.php');

	// IF SQL DATABASE
	if ($mg2->sqldatabase) {

		// CONNECT TO SQL SERVER
		$mg2->getSQLConnect();

		// READ SETTINGS FROM SQL DATABASE
		$mg2->read_sDBSQL();
	}

	// LOGIN SECURITY CHECK
	if (!isset($_SESSION[GALLERY_ID]['adminpwd']))					exit();
	if (strlen($_SESSION[GALLERY_ID]['adminpwd']) !== 40)			exit();
	if ($_SESSION[GALLERY_ID]['adminpwd'] !== $mg2->adminpwd)	exit();
	if (!isset($_SESSION[GALLERY_ID]['accesstime']))				exit();
	if (!isset($_SESSION[GALLERY_ID]['inactivetime']))				exit();
	$logoutTime = $_SESSION[GALLERY_ID]['accesstime']  +
					  $_SESSION[GALLERY_ID]['inactivetime'];
	if (time() > $logoutTime)												exit();

	// GET EXIF THUMB DATA
	$Exif		  = new MG2Exif();
	$exifData  = $Exif->getExifData(getImagePath($mg2));
	$thumbData = empty($exifData['ThumbData']) ?
					 file_get_contents(ADMIN_IMAGES .'no_exif_thumbnail.jpg')
					 :
					 $exifData['ThumbData'];

	// SEND THUMB DATA TO BROWSER
	sendImageStream($thumbData);
	exit();

	// GET QUERY VALUES FOR IMAGE PATH
	function getImagePath(&$mg2) {

		$fName  = trim($_GET['f']);
		$subdir = trim($_GET['s']);
		$filePath = false;

		do {
			// CHECK FILE NAME
			if ($fName === '')												break;	// no file name
			if (preg_match('#[:<>\/\\\|\?"]#', $fName))				break;	// forbidden chars

			// CHECK FILE EXTENSION
			$extension = substr(strrchr($fName, '.'), 1);
			if (!$mg2->checkFileExtension($extension))				break;	// extension forbidden

			// CHECK SUB DIR
			if ($subdir && preg_match('#:|\.\.|//|\?/#', $subdir))break;	// forbidden chars

			$filePath = $mg2->getFilePathByName($fName, $subdir);
		}
		while(0);

		return $filePath ? ROOT_FOLDER .'/'. $filePath:'';
	}

	// SEND THUMB DATA TO BROWSER
	function sendImageStream($thumbData) {

		// SEND APPROPRIATE IMAGE HEADERS TO BROWSER
		header('Content-Type: image/jpeg');											// file type
		header('Content-Transfer-Encoding: binary');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		header('Date: '. gmdate('D, d M Y H:i:s') .' GMT');					// server GMT date and time
		echo $thumbData;
	}
?>