<?php
	$gdInfo		 		= (function_exists('gd_info'))?
							  gd_info()
							  :
							  array('GD Version'=>' - ','FreeType Support'=>false);
	$gdVersion			= @preg_replace("/[a-z()\s]/i", "", $gdInfo['GD Version']);
	$gdFreeType			= ($gdInfo['FreeType Support'])?
							  'installed (Linkage '. $gdInfo['FreeType Linkage'] .')'
							  :
							  ' - ';
	$uploadFilesize	= ($cfg_var = ini_get('upload_max_filesize'))?
							  @preg_replace('/(\d+)M$/','${1} MBytes',$cfg_var)
							  :
							  '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$postLimit			= ($cfg_var = ini_get('post_max_size'))?
							  @preg_replace('/(\d+)M$/','${1} MBytes', $cfg_var)
							  :
							  '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$memoryLimit	 	= ($this->mg2->currentMemory['limit'] > 0)?
							  $this->mg2->convertBytes($this->mg2->currentMemory['limit'], 0)
							  :
							  '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$memory_get_usage	= ($this->mg2->currentMemory['allocate'] > 0)?
							  $this->mg2->convertBytes($this->mg2->currentMemory['allocate'], 1)
							  :
							  '<i>'. $this->mg2->lang['unknown'] .'</i>';
	$maxInputTime		= ($cfg_var = ini_get('max_input_time'))?
							  $cfg_var .' sec.'
							  :
							  '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$maxExecTime		= ($cfg_var = ini_get('max_execution_time'))?
							  $cfg_var .' sec.'
							  :
							  '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$safe_mode			= ini_get('safe_mode'); if (!$safe_mode) $safe_mode = '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$safe_mode_gid		= ini_get('safe_mode_gid'); if (!$safe_mode_gid) $safe_mode_gid = '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$safe_mode_include_dir = ini_get('safe_mode_include_dir'); if (!$safe_mode_include_dir) $safe_mode_include_dir = '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$safe_mode_exec_dir = ini_get('safe_mode_exec_dir'); if (!$safe_mode_exec_dir) $safe_mode_exec_dir = '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$safe_mode_allowed_env_vars = ini_get('safe_mode_allowed_env_vars'); if (!$safe_mode_allowed_env_vars) $safe_mode_allowed_env_vars = '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$safe_mode_protected_env_vars = ini_get('safe_mode_protected_env_vars'); if (!$safe_mode_protected_env_vars) $safe_mode_protected_env_vars = '<i>'. $this->mg2->lang['noentry'] .'</i>';
	$disable_functions = ini_get('disable_functions'); if (!$disable_functions) $disable_functions = '<i>'. $this->mg2->lang['noentry'] .'</i>';

	// ERROR REPORTING
	$errorReport = array();
	$errorValue	 = error_reporting();
	if ($errorValue & E_ERROR) $errorReport[] = 'E_ERROR';
	if ($errorValue & E_WARNING) $errorReport[] = 'E_WARNING';
	if ($errorValue & E_PARSE) $errorReport[] = 'E_PARSE';
	if ($errorValue & E_NOTICE) $errorReport[] = 'E_NOTICE';
	if ($errorValue & E_CORE_ERROR) $errorReport[] = 'E_CORE_ERROR';
	if ($errorValue & E_CORE_WARNING) $errorReport[] = 'E_CORE_WARNING';
	if ($errorValue & E_COMPILE_ERROR) $errorReport[] = 'E_COMPILE_ERROR';
	if ($errorValue & E_COMPILE_WARNING) $errorReport[] = 'E_COMPILE_WARNING';
	if ($errorValue & E_USER_ERROR) $errorReport[] = 'E_USER_ERROR';
	if ($errorValue & E_USER_WARNING) $errorReport[] = 'E_USER_WARNING';
	if ($errorValue & E_USER_NOTICE) $errorReport[] = 'E_USER_NOTICE';
	if (($errorValue & E_ALL) === E_ALL) $errorReport[] = 'E_ALL';
	if ($errorValue & E_STRICT) $errorReport[] = 'E_STRICT';
	if (empty($errorReport)) $errorReport[] = sprintf('<i>%s</i>', $this->mg2->lang['noentry']);

	// DIRECTORY PERMISSION
	clearstatcache();
	$imagefolder = (is_dir($this->mg2->imagefolder))?
						sprintf('%03o', fileperms($this->mg2->imagefolder) & 1023)
						:
						'<i>'.$this->mg2->lang['dontexists'].'</i>';
	$datafolder  = (is_dir(DATA_FOLDER))?
						 sprintf('%03o', fileperms(DATA_FOLDER) & 1023)
						:
						'<i>'.$this->mg2->lang['dontexists'].'</i>';
	$backupfolder= (is_dir(BACKUP_FOLDER))?
						 sprintf('%03o', fileperms(BACKUP_FOLDER) & 1023)
						:
						'<i>'.$this->mg2->lang['dontexists'].'</i>';

	// FILE PERMISSIONS
	$files = array(
				  'mg2db_folders'			=> 'php',
				  'mg2db_items'			=> 'php',
				  'mg2db_settings'		=> 'php',
				  'mg2db_counter'			=> 'php',
				  'mg2db_chronicle'		=> 'php',
				  'mg2db_keywords'	 	=> 'php',
				  'mg2db_item_keyword'	=> 'php',
				  'mg2_log'			 		=> 'txt'
				);
	foreach ($files as $filename=>$extension) {
		$file_path = sprintf('%s%s.%s', DATA_FOLDER, $filename, $extension);
		if (is_file($file_path))
			$$filename = sprintf('%03o (%s)',
								fileperms($file_path) & 1023,
								$this->mg2->convertBytes(filesize($file_path))
							 );
		else
			$$filename = '<i>'.$this->mg2->lang['dontexists'].'</i>';
	}

	// CURRENT USER NAME
	$current_user = get_current_user(); if (!$current_user) $current_user = '<i>'. $this->mg2->lang['noentry'] .'</i>';
?>
<br />
<table cellpadding="0" cellspacing="0" style="width:100%">
<tr valign="top">
	<td class="headline" colspan="2" style="border-right:0"><?php echo $this->mg2->lang['generellsettings'];?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="phpversion()"><?php echo $this->mg2->lang['php_version'];?>:</td>
	<td class="setup_noborder"><?php echo phpversion();?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="gd_info()"><?php echo $this->mg2->lang['gd_version'];?>:</td>
	<td class="setup_noborder"><?php echo $gdVersion;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="gd_info()">FreeType Support:</td>
	<td class="setup_noborder"><?php echo $gdFreeType;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="upload_max_filesize"><?php echo $this->mg2->lang['maxpostdata'];?></td>
	<td class="setup_noborder"><?php echo $uploadFilesize;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="post_max_size"><?php echo $this->mg2->lang['maxupload'];?></td>
	<td class="setup_noborder"><?php echo $postLimit;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="memory_limit"><?php echo $this->mg2->lang['memorylimit'];?></td>
	<td class="setup_noborder"><?php echo $memoryLimit;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="memory_get_usage()"><?php echo $this->mg2->lang['allocatedmemory'];?></td>
	<td class="setup_noborder"><?php echo $memory_get_usage;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="max_input_time">Max. Input Time:</td>
	<td class="setup_noborder"><?php echo $maxInputTime;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="max_execution_time">Max. Execution Time:</td>
	<td class="setup_noborder"><?php echo $maxExecTime;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="SELECT @@max_allowed_packet">Max. allowed packet (MySQL):</td>
	<td class="setup_noborder"><?php echo $maxMySQLPacket;?></td>
</tr>
<tr>
	<td class="setup" width="200" title="SELECT @@sql_mode"><?php echo $this->mg2->lang['sql_mode'];?>:</td>
	<td class="setup_bottom"><?php echo $sessionSQLMode;?></td>
</tr>
<tr valign="top">
  <td class="headline" colspan="2" style="border-right:0"><?php echo $this->mg2->lang['filepermissions'];?></td>
</tr>
<tr>
	<?php $root_dir = strrchr(str_replace('\\', '/', ROOT_FOLDER), '/');?>
	<td class="setup_right" width="200"><?php echo $this->normalizePath($root_dir .'/'. $this->mg2->imagefolder);?></td>
	<td class="setup_noborder"><?php echo $imagefolder;?></td>
</tr>
<tr>
	<td class="setup_right" width="200"><?php echo $root_dir, '/data';?></td>
	<td class="setup_noborder"><?php echo $datafolder;?></td>
</tr>
<tr>
	<td class="setup_right" width="200"><?php echo $root_dir, '/data/backup';?></td>
	<td class="setup_noborder"><?php echo $backupfolder;?></td>
</tr>
<tr>
	<td class="setup_right" width="200">mg2db_folders.php</td>
	<td class="setup_noborder"><?php echo $mg2db_folders;?></td>
</tr>
<tr>
	<td class="setup_right" width="200">mg2db_items.php</td>
	<td class="setup_noborder"><?php echo $mg2db_items;?></td>
</tr>
<tr>
	<td class="setup_right" width="200">mg2db_settings.php</td>
	<td class="setup_noborder"><?php echo $mg2db_settings;?></td>
</tr>
<tr>
	<td class="setup_right" width="200">mg2db_counter.php</td>
	<td class="setup_noborder"><?php echo $mg2db_counter;?></td>
</tr>
<tr>
	<td class="setup_right" width="200">mg2db_chronicle.php</td>
	<td class="setup_noborder"><?php echo $mg2db_chronicle;?></td>
</tr>
<tr>
	<td class="setup_right" width="200">mg2db_keywords.php</td>
	<td class="setup_noborder"><?php echo $mg2db_keywords;?></td>
</tr>
<tr>
	<td class="setup_right" width="200">mg2db_item_keyword.php</td>
	<td class="setup_noborder"><?php echo $mg2db_item_keyword;?></td>
</tr>
<tr>
	<td class="setup" width="200">mg2_log.txt</td>
	<td class="setup_bottom"><?php echo $mg2_log;?></td>
</tr>
<tr valign="top">
  <td class="headline" colspan="2" style="border-right:0"><?php echo $this->mg2->lang['locales'];?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="setlocale(LC_COLLATE, '0')">LC_COLLATE</td>
	<td class="setup_noborder"><?php echo setlocale(LC_COLLATE, '0');?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="setlocale(LC_CTYPE, '0')">LC_CTYPE</td>
	<td class="setup_noborder"><?php echo setlocale(LC_CTYPE, '0');?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="setlocale(LC_MONETARY, '0')">LC_MONETARY</td>
	<td class="setup_noborder"><?php echo setlocale(LC_MONETARY, '0');?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="setlocale(LC_NUMERIC, '0')">LC_NUMERIC</td>
	<td class="setup_noborder"><?php echo setlocale(LC_NUMERIC, '0');?></td>
</tr>
<tr>
	<td class="setup" width="200" title="setlocale(LC_TIME, '0')">LC_TIME</td>
	<td class="setup_bottom"><?php echo setlocale(LC_TIME, '0');?></td>
</tr>
<tr valign="top">
	<td class="headline" colspan="2" style="border-right:0"><?php echo $this->mg2->lang['safemodesettings'];?></td>
</tr>
<tr>
	<td class="setup_right" width="200">safe_mode:</td>
	<td class="setup_noborder"><?php echo $safe_mode;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="safe_mode_gid">safe_mode_gid:</td>
	<td class="setup_noborder"><?php echo $safe_mode_gid;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="safe_mode_include_dir">safe_mode_include_dir:</td>
	<td class="setup_noborder"><?php echo $safe_mode_include_dir;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="safe_mode_exec_dir">safe_mode_exec_dir:</td>
	<td class="setup_noborder"><?php echo $safe_mode_exec_dir;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="safe_mode_allowed_env_vars">safe_mode_allowed_env_vars:</td>
	<td class="setup_noborder"><?php echo $safe_mode_allowed_env_vars;?></td>
</tr>
<tr>
	<td class="setup" width="200" title="safe_mode_protected_env_vars">safe_mode_protected_env_vars:</td>
	<td class="setup_bottom"><?php echo $safe_mode_protected_env_vars;?></td>
</tr>
<tr valign="top">
	<td class="headline" colspan="2" style="border-right:0"><?php echo $this->mg2->lang['miscellaneous'];?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="php_uname()">Server OS:</td>
	<td class="setup_noborder"><?php echo php_uname();?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="php_sapi_name()">Server API:</td>
	<td class="setup_noborder"><?php echo php_sapi_name();?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="$_SERVER['SERVER_SOFTWARE']">Server Software:</td>
	<td class="setup_noborder"><?php echo $_SERVER['SERVER_SOFTWARE'];?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="get_current_user()">User name of this script:</td>
	<td class="setup_noborder"><?php echo $current_user;?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="getmyuid()">User ID of this script:</td>
	<td class="setup_noborder"><?php echo getmyuid();?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="getmygid()">Group ID of this script:</td>
	<td class="setup_noborder"><?php echo getmygid();?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="getmypid()">Prozess ID of this script:</td>
	<td class="setup_noborder"><?php echo getmypid();?></td>
</tr>
<tr>
	<td class="setup_right" width="200" title="disable_functions">disable_functions:</td>
	<td class="setup_noborder"><?php echo $disable_functions;?></td>
</tr>
<tr>
	<td class="setup" width="200" title="error_reporting()">error_reporting:</td>
	<td class="setup_bottom"><?php echo implode(', ',$errorReport);?></td>
</tr>
<tr>
	<td colspan="2" class="setup_noborder">
		<div style="text-align:center;margin:4px;">
<?php
		// CANCEL BUTTON
		printf("\n".'<a href="%s?fID=%d&amp;page=%s"><img src="%scancel.gif" width="24" height="24" alt="%5$s" title="%5$s" class="adminpicbutton" /></a>',
			ADMIN_INDEX,
			$folderID,
			$page,
			ADMIN_IMAGES,
			$this->mg2->lang['cancel']
		);
		// RELOAD BUTTON
		printf("\n".'<a href="%s?display=options&amp;tab=%d&amp;fID=%d&amp;page=%s"><img src="%sreload.gif" alt="%6$s" title="%6$s" class="adminpicbutton" /></a>',
			ADMIN_INDEX,
			$tab,
			$folderID,
			$page,
			ADMIN_IMAGES,
			$this->mg2->lang['reload']
		);
?> 
		</div>
	</td>
</tr>
</table>
