<?php
//
// VIEW HELPER CLASS ALSO EXTENDED BY "MG2ViewfolderHelper" OR "MG2ViewitemHelper"
// kh_mod 0.4.0 rc1, add
class MG2ViewHelper {

	var $mg2;	// parent object reference

	// INITIALIZE VIEW HELPER
	function MG2ViewHelper(&$parent) {
		$this->mg2 = &$parent;
	}

	function displayGalleryPwdDialog($itemID=-1) {

		$mg2 = &$this->mg2;

		$mg2->breadCrumbNav = $mg2->getBreadCrumbNav($mg2->all_folders[$mg2->pwdDialogfID][1]);
		$mg2->startImageURI = '';
		$mg2->headline		  = ($mg2->pwdDialogfID === 1)?	// root ?
									 $mg2->gallerytitle
									 :
									 $mg2->br2line($mg2->all_folders[$mg2->pwdDialogfID][2]);
		$mg2->pwdEnterText  = (empty($_POST['password']))?
									 $mg2->lang['enterpassword']
									 :
									 $mg2->lang['wronglogin'];
		$mg2->pwdConfirmURL = $mg2->getGalleryLink(($itemID < 1)?
									 array('fID'=>$mg2->pwdDialogfID)
									 :
									 array('iID'=>$itemID));

		$this->displayGalleryHead();
		include(SKIN_FOLDER .'templates/password.php');
		$this->displayGalleryFoot();
	}

	function displayGalleryHead($slideshow_start_icon=false, $slideshow_start_text=false) {

		$mg2 = &$this->mg2;

		// IF NOT SET "INCLUDE GALLERY"
		if (!($mg2->extendedset & 512)) {
			include(SKIN_FOLDER .'templates/gallery_header.php');
		}

		// CANVAS MARGIN AND WIDTH
		printf('<div class="mg2body" style="margin:%s;width:%s;">', $mg2->canvasMargin, $mg2->canvasWidth);

		// DISPLAY HEADLINE WITH BREADCRUMB-NAVIGATION
		if ($mg2->layoutsetting & (defined('FOLDERVIEW') ? 1:2)) {
			defined('SLIDESHOW') ?
			include(SKIN_FOLDER .'templates/slideshow_controls.php')
			:
			include(SKIN_FOLDER .'templates/viewheadline.php');
		}

		// CONTENT MARGIN AND WIDTH
		printf('<div style="margin:%s;width:%s;">', $mg2->contentMargin, $mg2->contentWidth);
	}

	function displayGalleryFoot() {

		// CLOSE CONTENT AND CANVAS MARGIN
		echo '</div></div>';

		// IF NOT SET "INCLUDE GALLERY"
		if (!($this->mg2->extendedset & 512)) {
			include(SKIN_FOLDER .'templates/gallery_footer.php');
		}
	}

	// GET JAVASCRIPT FUNCTION FOR SLIDESHOW
	function implementSlideshowJS() {

		// IF SET 'INCLUDE GALLERY' AND NOT PAUSE
		(($this->mg2->extendedset & 1<<9) && empty($_GET['pause']))?
		printf (
		'
		<script language="JavaScript" type="text/javascript">
		/* <![CDATA[ */
			function mg2_loadNextImage() {
				window.location.href = "%s";
			}
			function mg2_startTimer() {
				window.setTimeout("mg2_loadNextImage()", %d);
			}
			if (window.$) {
				$(window).load(function(){	mg2_startTimer(); });
			}
			else {
				window.onload = mg2_startTimer;
			}
		/* ]]> */
		</script>
		',
		$this->mg2->nexturl,
		$this->mg2->slideshowdelay * 1000
		)
		:
		'';
	}

	// DOWNLOAD ITEM
	function downloadItem($itemID) {

		$this->mg2->readDB();
		if (!isset($this->mg2->all_items[$itemID][1]))				exit();

		$folderID = (int)$this->mg2->all_items[$itemID][1];
		if (!$this->mg2->checkGalleryPassword($folderID, false)) exit();

		$filePath = $this->mg2->getFilePathByID($itemID);
		if (!is_file($filePath)) 											exit();

		// CHECK MODIFIED SCINCE HEADER
		$this->checkModifiedScince();

		header('Content-Description: File Transfer');
		header('Content-Type: application/x-download');													// file type
		header('Content-Disposition: attachment; filename='. basename($filePath));				// file name
		header('Content-Transfer-Encoding: binary');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		header('Content-Length: '. (string)filesize($filePath));										// file size
		header('Date: '. gmdate('D, d M Y H:i:s') .' GMT');											// server GMT date and time
		header('Last-Modified: '. gmdate('D, d M Y H:i:s', filemtime($filePath)) .' GMT');	// set last modified date

		// SEND FILE TO BROWSER
		$fp = fopen($filePath, 'rb');
		fpassthru($fp);
		fclose($fp);
		exit();
	}

	// IF MODIFIED SCINCE UP TO DATE
	function checkModifiedScince() {

		// READ ALL HTTP HEADERS
		if (function_exists('getallheaders') && $headers = getallheaders()) {
			// IF CACHE COPY STILL UP TO DATE, THEN DON'T SEND A NEW COPY
			if (!empty($headers['If-Modified-Since'])) {
				$ifModifiedSince = strtotime($headers['If-Modified-Since']);
				// IF CACHE COPY STILL UP TO DATE
				if ($ifModifiedSince >= filemtime($filePath)) {
					header('HTTP/1.1 304 Not Modified');	// do use local copy
					exit;
				}
			}
		}
	}
}
?>