<?php
/////////////////////////////
// DISPLAY ITEM
/////////////////////////////

	// LOAD VIEWITEM HELPER CLASS
	require_once(INC_FOLDER .'mg2_view_helper.php');
	require_once(INC_FOLDER .'mg2_viewitem_helper.php');
	$ViewitemHelper = &$mg2->getInstance('MG2ViewitemHelper');

	// CREATE THUMB NAVIGATION, USE SKIN SETTINGS
	$thumbset = array(
						'num' => (int)$skin_thumbnav_num,
						'div' => (float)$skin_thumbnav_size
					);
	list($currentPage, $prevID, $nextID) = $mg2->getItemNavigation($itemID, $thumbset);

	// GET ITEM DATA
	$fileName	 = trim($imageRC[6]);
	$subdir		 = trim($imageRC[7]);
	$fileNameURL = rawurlencode($fileName);
	$imagePath	 = $mg2->getFilePathByName($fileName, $subdir);
	$mediumPath  = $mg2->getFilePathByName($fileName, $subdir, 'medium');
	$contentType = $mg2->getContentType($itemID);
	$isItemNav	 = ((int)$mg2->navtype & 16)? true:false;

	// CHECK ITEM
	$mg2->lightboxURL = false;
	$mg2->switchURL	= false;
	if (!defined('FULLSIZE') && is_readable($mediumPath)) {
		list($mg2->width, $mg2->height, $mg2->type, $mg2->attr) = getimagesize($mediumPath);
		$mg2->imagefile	 = $mg2->getFilePathByName($fileNameURL, $subdir, 'medium');

		// IF FULLSIZE SWITCH ON
		if ($mg2->layoutsetting & 24576) {
			$mg2->switchURL	 = $mg2->getGalleryLink(array('iID'=>$itemID, 'fullsize'=>1));
			$mg2->switchTarget = '_self';
			$mg2->switchText   = $mg2->lang['fullsize'];
			// LIGHTBOX-EFFECT
			if (($mg2->layoutsetting & 24576) === 8192) {
				// INCLUDE GALLERY SCRIPT INTO HTML PAGE
				if ($mg2->extendedset & 1<<9) {
					$mg2->switchURL   = $mg2->getFilePathByName($fileNameURL, $subdir);
				} else {
					$mg2->lightboxURL = $mg2->getFilePathByName($fileNameURL, $subdir);
				}
			}
		}
	} elseif (is_readable($imagePath)) {
		$mg2->imagefile = $mg2->getFilePathByName($fileNameURL, $subdir);
		$mg2->width		 = (int)$imageRC[8];
		$mg2->height	 = (int)$imageRC[9];

		// IF FULLSIZE SWITCH ON
		if ((($mg2->layoutsetting & 24576)) && defined('FULLSIZE')) {
			$mg2->switchURL    = $mg2->getGalleryLink(array('iID'=>$itemID, 'fullsize'=>0));
			$mg2->switchTarget = '_self';
			$mg2->switchText   = $mg2->lang['mediumsize'];
		}
	} elseif (is_file($imagePath)) {
		$mg2->imagefile = SKIN_IMAGES .'1x1.gif';
		$mg2->width		 = (int)$imageRC[8];
		$mg2->height	 = (int)$imageRC[9];
		$mg2->status	 = $mg2->lang['filenotreadable'];
	} else {
		// ITEM DATABASE ENTRY OK, BUT NO ITEM EXISTS
		$mg2->notexists('noimage', $folderID, $currentPage);
	}

	// PROTECT IMAGE WITH TRANSPARENT GIF
	$mg2->background = '';
	if (($mg2->layoutsetting & 4) && isset($contentType['image'])) {
		$mg2->background = 'background-image:url('. addcslashes($mg2->imagefile, "'() ") .');';
		$mg2->imagefile  = SKIN_IMAGES .'1x1.gif';
	}

	// ALLOW TO ADD COMMENTS?
	if ($mg2->commentsets & 8) {
		list($workon, $verify, $hideCommForm) = $ViewitemHelper->addUserComment($itemID);
	}

	// DISPLAY GALLERY HEAD
	$mg2->breadCrumbNav = $mg2->getBreadCrumbNav($folderID);
	$mg2->startImageURI = $mg2->getGalleryLink(array('slideshow'=>$itemID, 'page'=>$currentPage));
	$mg2->description	  = ($mg2->layoutsetting & 32 && !$mg2->string_empty($imageRC[3]))? $imageRC[3]:'';
	$mg2->headline		  = ($mg2->layoutsetting &  8)?	// filename as headline?
								 $mg2->getFileName($itemID)
								 :
								 $mg2->br2line($imageRC[2]);
	$mg2->alt			  = ($mg2->layoutsetting & 16)?	// title as alt tag?
								 $mg2->htmlchars2entities($mg2->headline)
								 :
								 '';

	// NAVIGATION IMAGE MAP?
	if ($flagM = (int)$mg2->navtype & 224) {
		$ViewitemHelper->buildImageMap($flagM, $folderID, $currentPage, $prevID, $itemID, $nextID);
	}

	// IMAGE CONTENT
	if (isset($contentType['image']))
	{
		// INCLUDE COLORBOX ADDON
		if ($mg2->lightboxURL) {
			ob_start();
			include(ADDON_FOLDER .'colorbox/galHeadExtensionItem.php');
			$mg2->htmlHeadExtension = ob_get_contents();
			ob_end_clean();
		}

		$ViewitemHelper->displayGalleryHead($slideshow_start_icon, $slideshow_start_text);
		include(SKIN_FOLDER .'templates/viewimage.php');

		// DISPLAY EXIF DATA
		if ($mg2->showexif && ($exifDisplay = $ViewitemHelper->getExifData($imagePath, $imageRC[14]))) {
			include(SKIN_FOLDER .'templates/viewimage_exif.php');
		}
	}
	// FLASH CONTENT
	elseif (isset($contentType['flash']))
	{
		// GET SPLASH DATA
		$Splashes = &$mg2->getInstance('MG2Splashes');
		list(	$thumbID,
				$splashID,
				$backgrID,
				$splashColor,
				$flwp_bgColor) = $Splashes->getSplashRecord($itemID);

		// GET SPLASH AND FLASH BACKGROUND URLs
		$splashURL	= 'none';	// CSS like
		$flwp_bgURL = '';			// for 'flowplayer'
		if (isset($mg2->all_items[$splashID])) {
			$splashName = rawurlencode(trim($mg2->all_items[$splashID][6]));
			$splashPath = trim($mg2->all_items[$splashID][7]);
			$splashURL  = 'url('.$mg2->getFilePathByName($splashName, $splashPath).')';
		}
		if (isset($mg2->all_items[$backgrID])) {
			$backgrName = rawurlencode(trim($mg2->all_items[$backgrID][6]));
			$backgrPath = trim($mg2->all_items[$backgrID][7]);
			$flwp_bgURL = $mg2->getFilePathByName($backgrName, $backgrPath);
		}

		// IS SET SPLASH CONTENT
		$isSplash = ($splashColor{0} === '#' || $splashURL !== 'none')?
						 true
						 :
						 false;

		// GENERAL FLASH PLAYER SETTINGS
		$flwp_repeat	= 'repeat';	// e.g.: 'no-repeat', 'repeat-x'
		$flwp_gradient	= 'none';	// e.g.: '[0.3, 0]', 'none', 'low', 'medium', 'high'
		$flwp_scaling	= 'fit';		// 'scale' or 'fit'
		$flwp_opacity	= '0.65';	// 0 up to 1 (controlls)
		$flwp_volume	= 'true';
		$flwp_mute		= 'true';

		// VIDEO SETTINGS
		if (isset($contentType['video'])) {
			$playerStyle     = 'style1';	// 'none', 'style1' or 'style2'
			$flwp_controls	  = isset($contentType['swf']) ? false:true;
			$flwp_labelPlay  = $flwp_controls;
			$flwp_autoHide   = 'always';
			$flwp_fullscreen = 'true';
			$flwp_autoPlay	  = ($splashURL || $splashColor)? 'true':'false';
		}
		// AUDIO SETTINGS
		else {
			$playerStyle     = 'none';		// 'none', 'style1' or 'style2'
			$flwp_controls	  = true;
			$flwp_labelPlay  = false;
			$flwp_autoHide   = 'never';
			$flwp_fullscreen = 'false';
			$flwp_autoPlay   = 'true';
		}

		// INCLUDE FLOWPLAYER ADDON
		ob_start();
		include(ADDON_FOLDER .'flowplayer/galleryHeadExtension.php');
		$mg2->htmlHeadExtension = ob_get_contents();
		ob_end_clean();

		$ViewitemHelper->displayGalleryHead($slideshow_start_icon, $slideshow_start_text);
		include(SKIN_FOLDER .'templates/viewflash.php');
	}

	// DISPLAY AND/OR ADD COMMENTS?
	if ($mg2->commentsets & 9) {
		$Comments		= &$mg2->getInstance('MG2Comments');
		$itemComments	= $Comments->getComments($itemID);
		$numComments	= count($itemComments);
		$commFormLink	= $mg2->getGalleryLink(array('iID'=>$itemID, 'showform'=>1, 'rl'=>mt_rand(1,9999)));

		// INCLUDE COMMENT TEMPLATES
		if ($mg2->commentsets & 1 && ($numComments > 0))
			include(SKIN_FOLDER .'templates/comment_view.php');
		if ($mg2->commentsets & 8)
			include(SKIN_FOLDER .'templates/comment_form.php');
	}
	else $numComments = -1;

	// IS SET CLICK COUNTER?
	$countClicks = -1;
	do {
		if (isset($_GET['showform']))                                   break;
		if (isset($_GET['fullsize']))                                   break;
		if (!($mg2->foldersetting & 128) && !($mg2->extendedset & 256)) break;

		$countClicks = 1;
	}
	while(0);

	// IS SET COMMENT COUNTER?
	$countComment = (($mg2->foldersetting & 256) && $numComments >= 0)?
						 $numComments	// set number of comments
						 :
						 -1;				// don't set number of comments

	if ($countClicks === 1 || $countComment > -1) {
		$Counter = &$mg2->getInstance('MG2Counter');
		if ($countClicks || $Counter->getNumComments($itemID) !== $countComment) {
			$Counter->setDatabase($itemID, $countClicks, $countComment);
		}
	}

	// END OF PAGE
	$ViewitemHelper->displayGalleryFoot();
?> 
