<?php
//
// ADMIN BACKUP CLASS
// kh_mod 0.4.0 rc1, add
class MG2Backup {

	var $mg2;		// parent object reference
	var $sReadOK;	// read backup setting file OK

	// INITIALIZE BACKUP
	function MG2Backup(&$parent) {
		$this->mg2 = &$parent;
		require_once(INC_FOLDER .'mg2admin_counter.php');
	}

	// DATABASE BACKUP
	function backup_DB($backupData=array()) {

		// INIT VALUES
		$backupData = array_flip($backupData);
		$backupPath = $this->getBackupPath(time());	// raw backup path
		$messages	= array();								// status messages
		$backupMsg	= array(
							'fdatabase'		=> array('fdatabase', $this->mg2->lang['folderdata'],			 'Folder data'),	// for kh_mod < 0.4.0 b4
							'idatabase'		=> array('idatabase', $this->mg2->lang['imagedata'],			 'Item data'),		// for kh_mod < 0.4.0 b4
							'folders'		=> array('folders',	 $this->mg2->lang['folderdata'],			 'Folder data'),
							'items'			=> array('items',		 $this->mg2->lang['imagedata'],			 'Item data'),
							'splashes'		=> array('items',		 $this->mg2->lang['splashdata'],			 'Splash data'),
							'keywords'		=> array('keywords',	 $this->mg2->lang['keyworddata'],		 'Keyword'),
							'item_keyword'	=> array('keywords',	 $this->mg2->lang['item_keyword'],		 'Item - keyword'),
							'counter'		=> array('counter',	 $this->mg2->lang['counterdata'],		 'Counter'),
							'chronicle'		=> array('counter',	 $this->mg2->lang['counter_chronicle'], 'Counter chronicle'),
							'settings'		=> array('settings',	 $this->mg2->lang['setup'],				 'Setting data')
						  );

		foreach($backupMsg as $key=>$item) {
			if (!isset($backupData[$item[0]]))	continue;

			$path_source = DATA_FOLDER .'mg2db_'. $key .'.php';
			if ($this->mg2->sqldatabase || is_file($path_source)) {
				$result = $this->backup_DBaction($backupPath, $key);
				if ($result === true) {
					$messages[] = '<div>Backup '. $item[1] .' ok</div>';
					$this->mg2->log($item[2] .' backup complete');
				}
				elseif ($result === 0)
					$messages[] = sprintf('<div style="color:teal">%s There are no %s to backup</div>',
											$this->mg2->lang['notice'],
											$item[1]
									  );
				else
					$messages[] = sprintf('<div style="color:red">%s Couldn\'t write backup %s!</div>',
											$this->mg2->lang['error'],
											$item[1]
									  );
			} else {
				$messages[] = sprintf('<div style="color:teal">%s '. $this->mg2->lang['nofiletobackup'] .'</div>',
										$this->mg2->lang['notice'],
										$item[2],
										'mg2db_'. $key .'.php'
								  );
			}
		}

		(empty($messages))?
			$this->mg2->displayStatus($this->mg2->lang['nodataselected'], 1)
			:
			$this->mg2->displayStatus(implode('', $messages));
	}

	// DATABASE BACKUP ACTION
	function backup_DBaction($backupPath, $db) {

		// WHITE LIST FOR $db AND BACKUP FUNCTIONS
		$mapping = array(	'fdatabase'		=> 'write_fDBFlatfile',		// for kh_mod < 0.4.0 b4
								'idatabase'		=> 'write_iDBFlatfile',		// for kh_mod < 0.4.0 b4
								'folders'		=> 'write_fDBFlatfile',
								'items'			=> 'write_iDBFlatfile',
								'settings'		=> 'write_sDBFlatfile',
								'splashes'		=> 'backupDatabase',
								'keywords'		=> 'backupDatabase',
								'item_keyword'	=> 'backupDatabase',
								'counter'		=> 'backupDatabase',
								'chronicle'		=> 'backupDatabase'
					  );
		if (!isset($mapping[$db])) return false;

		// SQL DATABASE USED?
		if ($this->mg2->sqldatabase) {
			$writeBackup  = $mapping[$db];
			$tempFilePath = sprintf('%smg2db_%s_temp.php', DATA_FOLDER, $db);
			// COUNTER BACKUP
			if ($db === 'counter' ||  $db === 'chronicle') {
				$Counter = &$this->mg2->getInstance('MG2AdminCounter');
				$path_database = ($Counter->$writeBackup($db) > 0)?			// return {false, 0, 1, ..n}
									  $tempFilePath
									  :
									  false;
			}
			// SPLASHES BACKUP
			elseif ($db === 'splashes') {
				$Splashes = &$this->mg2->getInstance('MG2Splashes');
				$path_database = ($Splashes->$writeBackup() > 0)?				// return {false, 0, 1, .. n}
									  $tempFilePath
									  :
									  false;
			}
			// KEYWORDS BACKUP
			elseif ($db === 'keywords' || $db === 'item_keyword') {
				$Keywords = &$this->mg2->getInstance('MG2Keywords');
				$path_database = ($Keywords->$writeBackup($db) > 0)?			// return {false, 0, 1, .. n}
									  $tempFilePath
									  :
									  false;
			}
			// ALL OTHER BACKUPS
			else {
				$path_database = ($this->mg2->$writeBackup('backup') > 0)?	// return {false, -1, 0, 1, .. n}
										$tempFilePath
										:
										false;
			}
		}
		// FLAT FILE USED!
		else {
			$path_database = (filesize(DATA_FOLDER . 'mg2db_'. $db .'.php'))?
								  DATA_FOLDER . 'mg2db_'. $db .'.php'
								  :
								  false;
		}

		// BACKUP FILE
		return ($path_database === false)?	// no data to backup?
				 0
				 :
				 copy($path_database, sprintf($backupPath, $db));
	}

	// RESTORE BACKUP
	function restoreBackup() {
		$use_folders  = (isset($_POST['use_folders']))?  true:false;
		$use_items	  = (isset($_POST['use_items']))?    true:false;
		$use_keywords = (isset($_POST['use_keywords']))? true:false;
		$use_counter  = (isset($_POST['use_counter']))?  true:false;
		$use_settings = (isset($_POST['use_settings']))? true:false;

		$fTimestamp	  = (int)substr($_POST['folders'],0,10);
		$iTimestamp	  = (int)substr($_POST['items'],0,10);
		$kTimestamp	  = (int)substr($_POST['keywords'],0,10);
		$cTimestamp   = (int)substr($_POST['counter'],0,10);
		$sTimestamp   = (int)substr($_POST['settings'],0,10);

		// RESTORE MESSAGES
		$messages = array();
		$noDataRecords	= '<div style="color:teal">'.	$this->mg2->lang['notice'] .' There are no %s data to restore of %s</div>';
		$resetedData	= '<div style="color:teal">'.	$this->mg2->lang['notice'] .' %s are reset, because there isn\'t any backup record!</div>';
		$couldntRead	= '<div style="color:red">'.	$this->mg2->lang['error']  .' Couldn\'t read %s backup file \'%s_mg2db_%s.php\'!</div>';
		$restoreError	= '<div style="color:red">'.	$this->mg2->lang['error']  .' Couldn\'t restore %s backup of %s!</div>';
		$restorSuccess = sprintf('<div>'. $this->mg2->lang['restored_backup'] .'</div>',
									'%d '. $this->mg2->lang['of'] .' %d',
									'%s',
									'%s'
							  );
		$restoreNote	= sprintf('<div style="color:teal;">(%s %s)</div>',
									$this->mg2->lang['notice'],
									$this->mg2->lang['orphaned_entries']
							  );

		// RESTORE FOLDERS (TIME > 2005-01-01)
		if ($use_folders && ($fTimestamp > 1104534000)) {
			$restoreDate   = $this->mg2->time2date($fTimestamp, true, true);	// $showTime and $showDate
			$restorePath   = $this->getBackupPath($fTimestamp);
			$folderCurrent = $this->isCurrentBackup('folders');
			list(
				$foldersOK,
				$itemsOK
			) = $this->mg2->readDBFlatfile($restorePath, $folderCurrent);
			if ($foldersOK)
			{
				foreach (array_keys($this->mg2->all_folders) as $key)
				{
					// FOLDER TYPE (INTRODUCED IN KH_MOD 0.3.0 rc1)
					$this->mg2->all_folders[$key][11] = isset($this->mg2->all_folders[$key][11]) ?
																	(int)$this->mg2->all_folders[$key][11]
																	:
																	0;	// default folder

					// FOR LEGACY BACKUP FILES ('fdatabase', kh_mod 0.3.0 b5 up to 0.4.0 b3)
					if (!$folderCurrent)
					{
						// FOLDER URL (INTRODUCED IN KH_MOD 0.4.1)
						$this->mg2->all_folders[$key][12] = '';

						/**
						 * KH_MOD 0.3.0 FINAL UP TO 0.4.0 pl3, IF ID 11 === 1, THEN
						 * THE URL AND TARGET ARE LOCATED IN ID 9 AND 10;
						 *
						 * IN KH_MOD 0.3.0 RC1 AND RC2 WAS THE ID 11 VALUE '-1' FOR
						 * LINK FOLDER, BUT THAT'S NOT CONSIDERED HERE
						 */
						if ($this->mg2->all_folders[$key][11] === 1)
						{
							$targets   = array('_blank', '_self', '_parent', '_top');
							$folderURL = array(
								substr($this->mg2->cleanURLString($this->mg2->all_folders[$key][9]), 0, 228),
								(int)array_search(trim($this->mg2->all_folders[$key][10]), $targets, true)
							);
							$this->mg2->all_folders[$key][12] = serialize($folderURL);
						}
					}
				}

				$messages[] = (($records = $this->mg2->write_fDB('all')) !== -1)?
								  sprintf($restorSuccess,
										$records,
										$foldersOK,
										$this->mg2->lang['folderdata'],
										$restoreDate
								  )
								  :
								  sprintf($restoreError, 'folder', $restoreDate);
			}
			elseif ($foldersOK === 0) {
				$messages[] = sprintf($noDataRecords, 'folder', $restoreDate);
			}
			else {
				$messages[]	= sprintf($couldntRead, 'folder', $fTimestamp, 'folders');
			}
		}

		// RESTORE ITEMS (TIME > 2005-01-01)
		if ($use_items && ($iTimestamp > 1104534000))
		{
			$itemCurrent = $this->isCurrentBackup('items');
			if (!$use_folders
				 || ($iTimestamp  !== $fTimestamp)
				 || ($itemCurrent !== $folderCurrent))
			{
				$restoreDate = $this->mg2->time2date($iTimestamp, true, true);	// $showTime and $showDate
				$restorePath = $this->getBackupPath($iTimestamp);
				list(
					$foldersOK,
					$itemsOK
				) = $this->mg2->readDBFlatfile($restorePath, $itemCurrent);
			}
			if ($itemsOK)
			{
				// BACKUP FILES AS OF kh_mod 0.4.0 b4
				if ($itemCurrent)
				{
					// GET FILE TYPE AND LOCATION ONLY (BIT 1...12)
					foreach (array_keys($this->mg2->all_items) as $key) {
						$this->mg2->all_items[$key][13] = (int)$this->mg2->all_items[$key][13];
						$this->mg2->all_items[$key][14] = substr($this->mg2->all_items[$key][14], 0, 255);
						$this->mg2->all_items[$key][15] = (int)$this->mg2->all_items[$key][15];
						$this->mg2->all_items[$key][16] = empty($this->mg2->all_items[$key][16]) ?
							$this->mg2->getContentCode($this->mg2->getFileExtension($key))
							:
							(int)$this->mg2->all_items[$key][16] & 8191;
					}
				}
				// FOR LEGACY BACKUP FILES ('idatabase', kh_mod 0.3.0 b5 up to 0.4.0 b3)
				else {
					foreach (array_keys($this->mg2->all_items) as $key) {
						$this->mg2->all_items[$key][13] = 0; 																// exif date (original)
						$this->mg2->all_items[$key][14] = substr($this->mg2->all_items[$key][14], 0, 255);	// artist
						$this->mg2->all_items[$key][15] = 0;									// bookmark (introduced in kh_mod 0.4.0 b3)
						$this->mg2->all_items[$key][16] = $this->mg2->getContentCode(	// filetype and process state
							$this->mg2->getFileExtension($key)
						);
					}
				}

				// WRITE ITEM DATA
				if (($records = $this->mg2->write_iDB('all')) !== -1)
				{
					$messages[] = sprintf($restorSuccess,
											$records,
											$itemsOK,
											$this->mg2->lang['imagedata'],
											$restoreDate
									  );

					// RESTORE SPLASHES, kh_mod 0.4.0 b3 add
					$Splashes	= &$this->mg2->getInstance('MG2Splashes');						
					$splashesOK = $Splashes->restoreDatabase($restorePath);
					if ($splashesOK === -2) {
						$messages[]	= sprintf($couldntRead, 'splash', $iTimestamp, 'splashes');
					}
					elseif ($splashesOK === -1) {
						$messages[]	= sprintf($restoreError, 'splash', $restoreDate);
					}
					elseif ($splashesOK === 0) {
						$messages[]	= sprintf($resetedData, $this->mg2->lang['splashdata']);
					}
					elseif ($splashesOK > 0) {
						$messages[] = sprintf($restorSuccess,
												$splashesOK,
												$Splashes->getNumSplashes(),
												$this->mg2->lang['splashdata'],
												$restoreDate
										  );
					}
				}
				// COULD NOT WRITE ITEM DATA
				else {
					$messages[] = sprintf($restoreError, 'image', $restoreDate);
				}
			}
			// NO ITEM DATA TO RESTORE
			elseif ($itemsOK===0) {
				$messages[] = sprintf($noDataRecords, 'image', $restoreDate);
			}
			else {
				$messages[]	= sprintf($couldntRead, 'image', $iTimestamp, 'items');
			}
		}

		// RESTORE KEYWORDS (TIME > 2005-01-01)
		if ($use_keywords && ($kTimestamp > 1104534000)) {
			$restoreDate = $this->mg2->time2date($kTimestamp, true, true);
			$restorePath = $this->getBackupPath($kTimestamp);
			$Keywords	 = &$this->mg2->getInstance('MG2Keywords');						
			$result      = $Keywords->restoreDatabase($restorePath);

			// MESSAGES FOR RESTORED KEYWORD DATA
			if ($result === -2)
				$messages[]	= sprintf($couldntRead, 'keyword', $kTimestamp, 'keywords');
			elseif ($result === -1)
				$messages[]	= sprintf($restoreError, 'keyword', $restoreDate);
			else {
				if ($result['keywordData'] === 0) {
					$messages[] = sprintf($resetedData, $this->mg2->lang['keyworddata']);
				}
				else {
					$messages[] = sprintf($restorSuccess,
											$result['keywordData'],
											$result['keywordData'],
											$this->mg2->lang['keyworddata'],
											$restoreDate
									  );
				}

				// MESSAGES FOR RESTORED ITEM - KEYWORD DATA
				$nRestoredIDs = $result['keywordIndex']['total'] - $result['keywordIndex']['residue'];
				if ($result['keywordIndex']['total'] === 0) {
					$messages[] = sprintf($resetedData, $this->mg2->lang['item_keyword']);
				}
				else {
					$messages[] = sprintf($restorSuccess,
											$nRestoredIDs,
											$result['keywordIndex']['total'],
											$this->mg2->lang['item_keyword'],
											$restoreDate
									  );
					if ($result['keywordIndex']['residue']) {
						$messages[] = sprintf($restoreNote, $result['keywordIndex']['residue']);
					}
				}
			}
		}

		// RESTORE COUNTER (TIME > 2005-01-01)
		if ($use_counter && ($cTimestamp > 1104534000)) {
			$restoreDate = $this->mg2->time2date($cTimestamp);
			$restorePath = $this->getBackupPath($cTimestamp);
			$Counter		 = &$this->mg2->getInstance('MG2AdminCounter', true);
			$result		 = $Counter->restoreDatabase($restorePath);

			// MESSAGES FOR RESTORED COUNTER DATA
			if ($result['counter']['total'] === -2) {
				$messages[]	= sprintf($couldntRead, 'counter', $cTimestamp, 'counter');
			}
			elseif ($result['counter']['total'] === -1) {
				$messages[]	= sprintf($restoreError, 'counter', $restoreDate);
			}
			elseif ($result['counter']['total'] === 0) {
				$messages[] = sprintf($noDataRecords, 'counter', $restoreDate);
			}
			else {
				$nRestoredIDs = $result['counter']['total'] - $result['counter']['residue'];
				$messages[]   = sprintf($restorSuccess,
										 $nRestoredIDs, $result['counter']['total'],
										 $this->mg2->lang['counterdata'], $restoreDate
									 );
				if ($result['counter']['residue']) {
					$messages[] = sprintf($restoreNote, $result['counter']['residue']);
				}

				// MESSAGES FOR RESTORED CHRONICLE DATA
				if ($result['chronicle']['total'] === -1) {
					$messages[]	= sprintf($restoreError, 'chronicle', $restoreDate);
				}
				else {
					$nRestoredIDs = $result['chronicle']['total'] - $result['chronicle']['residue'];
					$messages[]   = sprintf($restorSuccess,
											 $nRestoredIDs, $result['chronicle']['total'],
											 $this->mg2->lang['counter_chronicle'],	$restoreDate
										 );
					if ($result['chronicle']['residue']) {
						$messages[] = sprintf($restoreNote, $result['chronicle']['residue']);
					}
				}
			}
		}

		// RESTORE SETTINGS (TIME > 2005-01-01)
		if ($use_settings && ($sTimestamp > 1104534000)) {
			if ($this->sReadOK) {
				$restoreDate =	$this->mg2->time2date($sTimestamp, true, true);
				$records     =	($this->mg2->sqldatabase)?
									$this->mg2->SQLWrite->write2SQLTable('settings')
									:
									$this->mg2->write_sDBFlatfile('flat');
				$messages[]  =	($records && ((int)$records !== -1))?
									sprintf('<div>'. $this->mg2->lang['restored_backup'] .'</div>',
										'',
										$this->mg2->lang['setup'],
										$restoreDate
									)
									:
									sprintf($restoreError, 'setting', $restoreDate);
			} else
				$messages[]  =	sprintf($couldntRead, 'setting', $sTimestamp, 'settings');
		}

		// $this->mg2->log('Database restore complete');
		(empty($messages))?
			$this->mg2->displayStatus($this->mg2->lang['nodataselected'] .' to restore!', 1)
			:
			$this->mg2->displayStatus(implode($messages));
	}

	// READ BACKUP OF SETTING, ACCESS BY 'admin.php'
	function readBackupSettings($sTimestamp) {

		// READ BACKUP
		$mg2           = new stdClass();
		$restorePath   = $this->getBackupPath($sTimestamp, 'settings');
		$this->sReadOK = is_readable($restorePath) ?
							  include($restorePath)
							  :
							  false;

		// CLEAR READ SETTING VALUES
		require_once(INC_FOLDER .'mg2admin_converter.php');
		$Converter = &$this->mg2->getInstance('MG2AdminConverter');
		$Settings  = $Converter->cleanSettingData($mg2);

		// OVERWRITE VALUES WHICH ARE NOT ALLOWED TO CHANGE
		$Settings->sqldatabase = isset($this->mg2->sqldatabase) ? (int)$this->mg2->sqldatabase:0;
		$Settings->installdate = isset($this->mg2->installdate) ? (int)$this->mg2->installdate:0;
		$Settings->modversion  = $this->mg2->modversion;
		$Settings->adminpwd    = $this->mg2->adminpwd;
		$Settings->adminsalt   = $this->mg2->adminsalt;

		// UPDATE SETTINGS IN THE OBJECT "MG2"
		foreach ((array)$Settings as $property=>$value) {
			$this->mg2->$property = $value;
		}
	}

	// DELETE BACKUP
	function deleteBackup() {

		$messages = array();
		$doDelete = array(
			'folders'		=> array('folders',	$this->mg2->lang['folderdata']),
			'items'			=> array('items',		$this->mg2->lang['imagedata']),
			'splashes'		=> array('items',		$this->mg2->lang['splashdata']),
			'keywords'		=> array('keywords',	$this->mg2->lang['keyworddata']),
			'item_keyword'	=> array('keywords',	$this->mg2->lang['item_keyword']),
			'counter'		=> array('counter',	$this->mg2->lang['counterdata']),
			'chronicle'		=> array('counter',	$this->mg2->lang['counter_chronicle']),
			'settings'		=> array('settings',	$this->mg2->lang['setup'])
		);

		foreach($doDelete as $key=>$item) {
			if ((int)$_POST['use_'. $item[0]] !== 1) continue;

			// CHECK FOR BUCKUP FILES OF KH_MOD 0.3.x
			if ($key === 'folders'
				 && !$this->isCurrentBackup($item[0]))
			{
				$key = 'fdatabase';
			}
			elseif ($key === 'items'
				 && !$this->isCurrentBackup($item[0]))
			{
				$key = 'idatabase';
			}
			elseif ($key === 'splashes'
				 && !$this->isCurrentBackup($item[0]))
			{
				continue;
			}

			$timestamp	= substr($_POST[$item[0]], 0, 10);
			$backupDate	= $this->mg2->time2date($timestamp, true, true);
			$backupPath = $this->getBackupPath($timestamp, $key);
			if (is_file($backupPath)) {
				$messages[] = unlink($backupPath)?
								  sprintf('<div>'. $this->mg2->lang['deleted_backup'] .'</div>', $item[1], $backupDate)
								  :
								  sprintf('<div style="color:red">%s Couldn\'t delete %s backup!</div>', $this->mg2->lang['error'], $item[1]);
			}
			elseif ((int)$timestamp !== -1) {
				$messages[] = sprintf('<div style="color:teal">%s There\'s no %s backup to delete!</div>',
										$this->mg2->lang['notice'],
										$item[1]
								  );
			}
		}

		// $this->mg2->log('Database delete complete');
		empty($messages) ?
		$this->mg2->displayStatus($this->mg2->lang['nodataselected'] .' to delete!', 1)
		:
		$this->mg2->displayStatus(implode($messages));
	}

	// BUILD BACKUP PATH
	function getBackupPath($timestamp, $file='%s') {

		// INIT RETURN VALUE
		$backupPath = false;

		do {
			if ((strlen($timestamp) !== 10))								break;
			if (!is_dir(BACKUP_FOLDER) && !mkdir(BACKUP_FOLDER))	break;

			// BACKUP FILE
			$backupPath = sprintf('%s%d_mg2db_%s.php', BACKUP_FOLDER, $timestamp, $file);
		}
		while(0);

		return $backupPath;
	}

	// CURRENT BACKUP FILE OR ONE BY KH_MOD v0.3.x
	function isCurrentBackup($name) {
		return substr($_POST[$name], -6) !== 'v0.3.x' ? true:false;
	}
}
?>