<?php
///////////////////////////////////////////////////////////////////////////////////
//                                                                               //
//	kh_mod                                                                        //
//	A PHP/SQL image gallery script based on MG2                                   //
//	http://www.minigal.de													                  //
//	support@minigal.de                                                            //
//                                                                               //
//	Project started: Oct/01 2006                                                  //
//                                                                               //
//    kh_mod is free software; you can redistribute it and/or modify             //
//    it under the terms of the GNU General Public License as published by       //
//    the Free Software Foundation version 2.                                    //
//                                                                               //
///////////////////////////////////////////////////////////////////////////////////

class DBSwitch {

	var $mg2;	// parent object reference

	// INITIALIZE DBSWITCH
	function DBSwitch(&$parent) {
		$this->mg2 = &$parent;
		require_once(INC_FOLDER .'mg2admin_counter.php');
	}

	// SWITCH FROM SQL TO FLATFILE
	function switch2Flatfile() {

		// INIT WRITE STATUS
		$fWriteOK = $iWriteOK = $pWriteOK = $cWriteOK = $kWriteOK = $sWriteOK = false;

		// FLAT FILES
		$fFlatFile = 'mg2db_folders.php';
		$iFlatFile = 'mg2db_items.php';
		$pFlatFile = 'mg2db_splashes.php';
		$cFlatFile = 'mg2db_counter.php';
		$kFlatFile = 'mg2db_keywords.php';
		$rFlatFile = 'mg2db_item_keyword.php';
		$sFlatFile = 'mg2db_settings.php';

		// WRITE FLAT FILES
		$Splashes = &$this->mg2->getInstance('MG2Splashes');
		$Counter  = &$this->mg2->getInstance('MG2AdminCounter');
		$Keywords = &$this->mg2->getInstance('MG2Keywords');
		if (($fWriteNum = $this->mg2->write_fDBFlatfile()) >= 1)					$fWriteOK = true;	// have to be one record at least
		if (($iWriteNum = $this->mg2->write_iDBFlatfile()) >= 0)					$iWriteOK = true;	// must not -1
		if (($pWriteNum = $Splashes->switchDatabase('flat')) >= 0)				$pWriteOK = true;	// must not -1
		if (($cWriteNum = $Counter->switchDatabase('flat'))  >= 0)				$cWriteOK = true;	// must not -1
		if (($kWriteNum = $Keywords->switchDatabase('flat')) >= 0)				$kWriteOK = true;	// must not -1
		if ($fWriteOK && $iWriteOK && $pWriteOK && $cWriteOK && $kWriteOK)	$sWriteOK = $this->mg2->write_sDBFlatfile();

		// CREATE FLAT FILE MESSAGES
		$this->mg2->status = '<div>';
		$this->mg2->status.= ($fWriteOK)?
									$fWriteNum .' Folder records written to \''. $fFlatFile .'\'.'
									:
									'Couldn\'t write folders in directory \''. DATA_FOLDER .'\'!';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($iWriteOK)?
									$iWriteNum .' Item records written to \''. $iFlatFile .'\'.'
									:
									'Couldn\'t write items in directory \''. DATA_FOLDER .'\'!';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($pWriteOK)?
									$pWriteNum .' Splash records written to \''. $pFlatFile .'\'.'
									:
									'Couldn\'t write splashes in directory \''. DATA_FOLDER .'\'!';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($cWriteOK)?
									$cWriteNum[0] .' Counter records written to \''. $cFlatFile .'\'.'
									.'</div><div>'.
									$cWriteNum[1] .' Counter chronicle records written to \''. $cFlatFile .'\'.'
									:
									'Couldn\'t write counter in directory \''. DATA_FOLDER .'\'!';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($kWriteOK)?
									$kWriteNum[0] .' Keyword records written to \''. $kFlatFile .'\'.'
									.'</div><div>'.
									$kWriteNum[1] .' Item &ndash; Keyword records written to \''. $rFlatFile .'\'.'
									:
									'Couldn\'t write keywords in directory \''. DATA_FOLDER .'\'!';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($sWriteOK)?
									'Settings written to \''. $sFlatFile .'\'.'
									:
									'Couldn\'t write settings in directory \''. DATA_FOLDER .'\'!';
		$this->mg2->status.= '</div>';
		return $sWriteOK;
	}

	// SWITCH FROM FLATFILE TO MySQL
	function switch2MySQL() {

		// GET DATABASE PARAMETER
		include_once(INC_FOLDER .'mg2admin_sqlstart.php');

		// CONNECT TO SQL SERVER
		if (!$this->mg2->getSQLConnect()) {
			$this->mg2->status = sprintf('
											<div style="color:#C69023;">
												%s %s
											</div>',
											$this->mg2->lang['warning'],
											'MySQL &ndash; No database connect!'
										);

			return false;
		}

		// GET SQL-SERVER VERSION
		$currMySQLVersion = mg2mysql_get_server_info();
		$minMySQLVersion  = '4.1.7';

		if (version_compare(preg_replace('/[^0-9\.]/', '', $currMySQLVersion), $minMySQLVersion, '<')) {
			$this->mg2->status = sprintf('
											<div style="color:teal;width:36em;margin:0 auto;">
												%s '. $this->mg2->lang['newermysql_required'] .'
											</div>',
											$this->mg2->lang['notice'],
											$currMySQLVersion,
											$minMySQLVersion
										);
			return false;
		}

		// INIT WRITE STATUS
		$fWriteOK = $iWriteOK = $pWriteOK = $cWriteOK = $kWriteOK = $sWriteOK = false;

		// SQL TABLES
		$prefix ='mg2db_';
		$fTable = 'folders';
		$iTable = 'items';
		$pTable = 'splashes';
		$cTable = 'counter';
		$hTable = 'chronicle';
		$kTable = 'keywords';
		$rTable = 'item_keyword';
		$sTable = 'settings';

		// CREATE SQL TABLES
		$fCreateOK = $this->createSQLTable($fTable, $prefix);	// folders
		$iCreateOK = $this->createSQLTable($iTable, $prefix);	// items
		$pCreateOK = $this->createSQLTable($pTable, $prefix);	// splashes
		$cCreateOK = $this->createSQLTable($cTable, $prefix);	// counter
		$hCreateOK = $this->createSQLTable($hTable, $prefix);	// chronicle
		$kCreateOK = $this->createSQLTable($kTable, $prefix);	// keywords
		$rCreateOK = $this->createSQLTable($rTable, $prefix);	// item keword relation
		$sCreateOK = $this->createSQLTable($sTable, $prefix);	// settings

		// LOAD AND INITIALIZE SQL WRITE
		require_once(INC_FOLDER .'mg2admin_sqlwrite.php');
		$SQLWrite = &$this->mg2->getInstance('SQLWrite');

		// WRITE DATA INTO TABLES
		if ($fCreateOK && $iCreateOK && $pCreateOK && $cCreateOK && $kCreateOK && $rCreateOK && $sCreateOK)
		do {
			if (($fWriteNum = $SQLWrite->write2SQLTable($fTable)) < 1)	break;	// have to be one record or more
			$fWriteOK = true;

			if (($iWriteNum = $SQLWrite->write2SQLTable($iTable)) < 0)	break;	// must not -1
			$iWriteOK = true;

			$Splashes = &$this->mg2->getInstance('MG2Splashes');
			if (($pWriteNum = $Splashes->switchDatabase('sql')) < 0)		break;	// must not -1
			$pWriteOK = true;

			$Counter = &$this->mg2->getInstance('MG2AdminCounter');
			if (($cWriteNum = $Counter->switchDatabase('sql')) < 0)		break;	// must not -1
			$cWriteOK = true;

			$Keywords = &$this->mg2->getInstance('MG2Keywords');
			if (($kWriteNum = $Keywords->switchDatabase('sql')) < 0)		break;	// must not -1
			$kWriteOK = true;

			// SWITCH TO SQL
			$sWriteOK = $SQLWrite->write2SQLTable($sTable);
		}
		while(0);

		// DATABASE CONNECT MESSAGE WITH MYSQL VERSION
		$this->mg2->status = '<div>DB connect OK, MySQL-Version: '. $currMySQLVersion .'</div>';

		// CREATE TABLE MESSAGES
		$this->mg2->status.= '<div style="margin-top: 1em">';
		$this->mg2->status.= ($fCreateOK)?
									'MySQL folder table \''. $prefix . $fTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create folder table!</span>';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($iCreateOK)?
									'MySQL item table \''. $prefix . $iTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create item table!</span>';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($pCreateOK)?
									'MySQL splash table \''. $prefix . $pTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create splash table!</span>';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($cCreateOK)?
									'MySQL counter table \''. $prefix . $cTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create counter table!</span>';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($hCreateOK)?
									'MySQL counter chronicle table \''. $prefix . $hTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create chronicle table!</span>';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($kCreateOK)?
									'MySQL keyword table \''. $prefix . $kTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create keyword table!</span>';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($rCreateOK)?
									'MySQL item &ndash; keyword table \''. $prefix . $rTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create item - keyword table!</span>';
		$this->mg2->status.= '</div><div>';
		$this->mg2->status.= ($sCreateOK)?
									'MySQL setting table \''. $prefix . $sTable .'\' created.'
									:
									'<span style="color:#C69023;">'. $this->mg2->lang['warning'] .' Couldn\'t create setting table!</span>';
		$this->mg2->status.= '</div>';

		// HAVE BEEN CREATED ALL SQL TABLES? THEN BUILD WRITE MESSAGES!
		if ($fCreateOK && $iCreateOK && $pCreateOK && $cCreateOK && $sCreateOK) {
			$this->mg2->status.= '<div style="margin-top: 1em">';
			$this->mg2->status.= ($fWriteOK)?
										$fWriteNum .' Folder records written into table \''. $prefix . $fTable .'\'.'
										:
										'Couldn\'t write folders values into MySQL!';
			$this->mg2->status.= '</div><div>';
			$this->mg2->status.= ($iWriteOK)?
										$iWriteNum .' Item records written into table \''. $prefix . $iTable .'\'.'
										:
										'Couldn\'t write item values into MySQL!';
			$this->mg2->status.= '</div><div>';
			$this->mg2->status.= ($pWriteOK)?
										$pWriteNum .' Splash records written into table \''. $prefix . $pTable .'\'.'
										:
										'Couldn\'t write splash values into MySQL!';
			$this->mg2->status.= '</div><div>';
			$this->mg2->status.= ($cWriteOK)?
										$cWriteNum[0] .' Counter records written into table \''. $prefix . $cTable .'\'.'
										.'</div><div>'.
										$cWriteNum[1] .' Counter chronicle records written into table \''. $prefix . $hTable .'\'.'
										:
										'Couldn\'t write counter values into MySQL!';
			$this->mg2->status.= '</div><div>';
			$this->mg2->status.= ($kWriteOK)?
										$kWriteNum[0] .' Keyword records written into table \''. $prefix . $kTable .'\'.'
										.'</div><div>'.
										$kWriteNum[1] .' Item &ndash; Keyword records written into table \''. $prefix . $rTable .'\'.'
										:
										'Couldn\'t write keyword values into MySQL!';
			$this->mg2->status.= '</div><div>';
			$this->mg2->status.= ($sWriteOK)?
										'Settings written into table \''. $prefix . $sTable .'\'.'
										:
										'Couldn\'t write settings into MySQL!';
			$this->mg2->status.= '</div>';
		}

		return $sWriteOK;
	}

	// CREATE A SQL TABLE
	function createSQLTable($table, $prefix='mg2db_') {
		switch ($table) {
			case 'folders'      :
			case 'items'        :
			case 'splashes'     :
			case 'settings'     :
			case 'counter'	     :
			case 'chronicle'	  :
			case 'keywords'     :
			case 'item_keyword' : break;
			default: return false;
		}

		return (mg2mysql_query('DROP TABLE IF EXISTS `'. $prefix . $table .'`'))?
				 mg2mysql_query($this->defineSQLTable($table, $prefix))
				 :
				 false;
	}

	// DEFINE A SQL TABLE
	function defineSQLTable($table, $prefix) {
		switch($table) {
			// FOLDER TABLE
			case 'folders': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`folderID` INT UNSIGNED NOT NULL,
					`parentID` VARCHAR(32) NOT NULL DEFAULT "root",
					`name` VARCHAR(255) NOT NULL DEFAULT "",
					`introText` TEXT NOT NULL,
					`timestamp` INT UNSIGNED NOT NULL DEFAULT 0,
					`position` INT NOT NULL DEFAULT 1,
					`thumbID` INT NOT NULL DEFAULT 0,
					`sortMode` SMALLINT UNSIGNED NOT NULL DEFAULT 1,
					`pwdHash` VARCHAR(32) NOT NULL DEFAULT "",
					`itemThumbCols` INT UNSIGNED NOT NULL DEFAULT 0,
					`itemThumbRows` INT UNSIGNED NOT NULL DEFAULT 0,
					`foldertype` INT NOT NULL DEFAULT 0,
					`url` VARCHAR(255) NOT NULL DEFAULT "",
					PRIMARY KEY (`folderID`)
				) ENGINE=MyISAM CHARACTER SET='. $this->getMySQLCharset();
			// ITEM TABLE
			case 'items': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`itemID` INT UNSIGNED NOT NULL,
					`folderID` INT UNSIGNED NOT NULL DEFAULT 1,
					`title` VARCHAR(255) NOT NULL DEFAULT "",
					`description` TEXT NOT NULL,
					`timestamp` INT UNSIGNED NOT NULL DEFAULT 0,
					`position` INT NOT NULL DEFAULT 1,
					`filename` VARCHAR(255) NOT NULL,
					`filepath` TEXT NOT NULL,
					`imageWidth` INT UNSIGNED NOT NULL,
					`imageHeight` INT UNSIGNED NOT NULL,
					`thumbWidth` INT UNSIGNED NOT NULL,
					`thumbHeight` INT UNSIGNED NOT NULL,
					`filesize` INT UNSIGNED NOT NULL,
					`exifDate` INT DEFAULT NULL,
					`artist` VARCHAR(255) NOT NULL DEFAULT "",
					`bookmarked` INT UNSIGNED DEFAULT NULL,
					`fileType` MEDIUMINT UNSIGNED NOT NULL DEFAULT 0,
					PRIMARY KEY (`itemID`)
				) ENGINE=MyISAM CHARACTER SET='. $this->getMySQLCharset();
			// SETTINGS TABLE
			case 'settings': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`settingID` INT UNSIGNED NOT NULL DEFAULT 1,
					`gallerytitle` VARCHAR(255) NOT NULL DEFAULT "My gallery",
					`adminemail` VARCHAR(255) NOT NULL,
					`metasetting` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 81,
					`defaultlang` VARCHAR(64) NOT NULL DEFAULT "english.php",
					`activeskin` VARCHAR(64) NOT NULL DEFAULT "subtel",
					`dateformat` VARCHAR(64) NOT NULL DEFAULT "%d.%m.%Y",
					`timeformat` VARCHAR(64) NOT NULL DEFAULT "%H.%M.%S",
					`navtype` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 113,
					`showexif` INT(10) UNSIGNED NOT NULL DEFAULT 510,
					`commentsets` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 159,
					`foldersetting` MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 544,
					`marknew` INT(10) UNSIGNED NOT NULL DEFAULT 7,
					`copyright` VARCHAR(255) NOT NULL DEFAULT "Copyright &copy; 2015",
					`adminpwd` VARCHAR(40) NOT NULL DEFAULT "",
					`adminsalt` VARCHAR(40) NOT NULL DEFAULT "",
					`extensions` INT(10) UNSIGNED NOT NULL DEFAULT 1711,
					`canvasWidth` VARCHAR(20) NOT NULL DEFAULT "auto",
					`contentWidth` VARCHAR(20) NOT NULL DEFAULT "auto",
					`introWidth` VARCHAR(20) NOT NULL DEFAULT "auto",
					`mediumimage` VARCHAR(20) NOT NULL DEFAULT "924",
					`indexfile` VARCHAR(255) NOT NULL DEFAULT "index.php",
					`imagefolder` VARCHAR(255) NOT NULL DEFAULT "pictures",
					`layoutsetting` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 8307,
					`thumbquality` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 85,
					`thumbMaxWidth` INT(10) UNSIGNED NOT NULL DEFAULT 150,
					`thumbMaxHeight` INT(10) UNSIGNED NOT NULL DEFAULT 150,
					`itemThumbCols` INT(10) UNSIGNED NOT NULL DEFAULT 4,
					`itemThumbRows` INT(10) UNSIGNED NOT NULL DEFAULT 6,
					`slideshowdelay` INT(10) UNSIGNED NOT NULL DEFAULT 8,
					`websitelink` TEXT NOT NULL,
					`websitetext` VARCHAR(255) NOT NULL DEFAULT "Home",
					`inactivetime` SMALLINT(5) UNSIGNED NOT NULL DEFAULT 15,
					`extendedset` MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 10460,
					`statisticsets` MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 144,
					`modversion` VARCHAR(15) NOT NULL DEFAULT "",
					`installdate` INT(10) NOT NULL DEFAULT -1,
					PRIMARY KEY (`settingID`)
				) ENGINE=MyISAM CHARACTER SET='. $this->getMySQLCharset();
			// COUNTER TABLE
			case 'counter': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`itemID` INT(10) UNSIGNED NOT NULL,
					`itemClicks` INT(10) UNSIGNED NOT NULL DEFAULT 0,
					`firstClick` INT(10) UNSIGNED NOT NULL,
					`lastClick` INT(10) UNSIGNED DEFAULT NULL,
					`commentsNum` INT(10) UNSIGNED DEFAULT NULL,
					`commentsOk` TINYINT(3) UNSIGNED NOT NULL DEFAULT 0,
					`ratingAvg` FLOAT DEFAULT NULL,
					`ratingNum` INT(10) UNSIGNED DEFAULT NULL,
					PRIMARY KEY (`itemID`)
				) ENGINE=MyISAM CHARACTER SET=latin1';
			// COUNTER CHRONICLE TABLE
			case 'chronicle': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`date` DATE NOT NULL ,
					`itemID` INT(10) UNSIGNED NOT NULL ,
					`itemClicks` INT(10) UNSIGNED NOT NULL ,
					`lastClick` INT(10) UNSIGNED DEFAULT NULL,
					`dateCode` TINYINT(3) UNSIGNED NOT NULL ,
					PRIMARY KEY (`date`, `itemID`)
				) ENGINE=MYISAM CHARACTER SET=latin1
				  COMMENT="counter chronicle for stats"';
			// SPLASHES TABLE
			case 'splashes': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`itemID` INT UNSIGNED NOT NULL,
					`thumbID` INT UNSIGNED NOT NULL,
					`splashID` INT UNSIGNED NOT NULL,
					`backgroundID` INT UNSIGNED NOT NULL,
					`splashColor` INT NOT NULL DEFAULT -1,
					`bgColor` INT NOT NULL DEFAULT -1,
					`options` INT UNSIGNED NOT NULL DEFAULT 0,
					PRIMARY KEY (`itemID`)
				) ENGINE=MyISAM CHARACTER SET=latin1';
			// KEYWORD - INDEX TABLE
			case 'keywords': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`keywordID` INT UNSIGNED NOT NULL,
					`keywordName` VARCHAR(255) NOT NULL,
					`introText` TEXT NOT NULL,
					`timestamp` INT NOT NULL DEFAULT -1,
					`position` INT NOT NULL DEFAULT 1,
					`sortMode` SMALLINT UNSIGNED NOT NULL DEFAULT 1,
					`pwdHash` VARCHAR(32) NOT NULL DEFAULT "",
					`itemThumbCols` INT UNSIGNED NOT NULL DEFAULT 0,
					`itemThumbRows` INT UNSIGNED NOT NULL DEFAULT 0,
					PRIMARY KEY (`keywordID`),
					UNIQUE KEY (`keywordName`)
				) ENGINE=MyISAM CHARACTER SET='. $this->getMySQLCharset();
			// ITEM - KEYWORD RELATION
			case 'item_keyword': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`itemID` INT UNSIGNED NOT NULL,
					`keywordID` INT UNSIGNED NOT NULL,
					`position` SMALLINT(5) UNSIGNED NOT NULL,
					PRIMARY KEY (`itemID`, `keywordID`)
				) ENGINE=MyISAM CHARACTER SET=latin1';
			// ITEM DESCRIPTION TABLE
			case 'idescription': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`itemID` INT UNSIGNED NOT NULL,
					`description` TEXT NOT NULL,
					PRIMARY KEY (`itemID`)
				) ENGINE=MyISAM CHARACTER SET='. $this->getMySQLCharset();
			// ITEM - SUBPATH TABLE
			case 'isubpath': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`subpathID` INT UNSIGNED NOT NULL,
					`filepath` TEXT NOT NULL,
					PRIMARY KEY (`subpathID`)
				) ENGINE=MyISAM CHARACTER SET='. $this->getMySQLCharset();
			// COMMENT TABLE
			case 'comments': return
				'CREATE TABLE `'. $prefix . $table .'` (
					`itemID` INT(10) UNSIGNED NOT NULL,
					`commentID` INT(10) UNSIGNED NOT NULL,
					`userName` VARCHAR(255) NOT NULL,
					`userEmail` VARCHAR(255) NOT NULL,
					`userComment` TEXT NOT NULL,
					`timestampNew` INT(10) UNSIGNED NOT NULL,
					`timestampChange` INT(10) UNSIGNED DEFAULT NULL,
					`numChanges` INT(10) UNSIGNED NOT NULL DEFAULT 0,
					`display` TINYINT(4) NOT NULL DEFAULT 1,
					PRIMARY KEY (`itemID`, `commentID`)
				) ENGINE=MyISAM CHARACTER SET='. $this->getMySQLCharset();
		}
		return false;
	}

	// GET CHARSET FOR MYSQL DATABASE
	function getMySQLCharset() {

		switch (strtolower($this->mg2->charset)) {
			case 'utf-8':			return 'utf8';
			case 'ucs-2':			return 'ucs2';
			case 'big5':			return 'big5';
			case 'koi8-r':			return 'koi8r';
			case 'cp1252':
			case 'latin1':
			case 'iso-8859-1':	return 'latin1';
			case 'latin2':
			case 'iso-8859-2':	return 'latin2';
			case 'iso-8859-7':	return 'greek';
			case 'iso-8859-8':	return 'hebrew';
			case 'iso-8859-9':	return 'latin5';
			case 'iso-8859-13':	return 'latin7';
			case 'gb2312': 		return 'gb2312';
			case 'gbk': 			return 'gbk';
			case 'eucjpms':
			case 'euc-jp': 		return 'ujis';
			case 'cp932':
			case 'shift-jis': 	return 'sjis';
			case 'armscii-8':		return 'armscii8';
			case 'cp1250':			return 'cp1250';
			case 'cp1251':			return 'cp1251';
			case 'cp1256':			return 'cp1256';
			case 'cp1257':			return 'cp1257';
			case 'geostd8':		return 'geostd8';
			default:					return 'latin1';
		}
	}
}
?>