<?php
//
// OPTIONS CLASS, IMPLEMENTATION SHOULD BE AS SINGLETON
// kh_mod 0.4.0 b4
class MG2Options {

	var $mg2; // parent object reference

	// INITIALIZE OPTIONS
	function MG2Options(&$parent) {
		$this->mg2 = &$parent;
	}

	// SETUP, DATABASE, SERVER, LOGFILE - TAB MENU CONTROL
	function tabMenu($folderID, $page) {

		// TAB CONTROL
		$tab = (isset($_REQUEST['tab']))? (int)$_REQUEST['tab']:0;

		// TAB NAME
		$tab_array = array(
							$this->mg2->lang['setup'],
							$this->mg2->lang['data'],
							$this->mg2->lang['stats'],
							$this->mg2->lang['server'],
							$this->mg2->lang['logfile']
						 );

		// INCLUDE FILE
		$inc_array = array(
							ADMIN_FOLDER .'options/admin_setup.inc.php',
							ADMIN_FOLDER .'options/admin_data.inc.php',
							ADMIN_FOLDER .'options/admin_stats.inc.php',
							ADMIN_FOLDER .'options/admin_server.inc.php',
							ADMIN_FOLDER .'options/admin_logfile.inc.php',
						 );

		// EXCUTE COMMANDS
		$exc_array = array(
							'setup',
							'data',
							'stats',
							'server',
							'logfile',
							'dailystats'
						 );

		switch ($exc_array[$tab]) {
			case 'setup':
					// GET LANGUAGES
					$exists = false;
					$langs  = array();
					$regexp = '/^[a-z]{2}(_|-)[a-z]{2}$/i';
					if ($workdir = opendir(LANG_FOLDER)) {
						while (false !== ($pointer = readdir($workdir))) {
							if ($pointer{0} === '.')				 					continue;
							if (!is_dir(LANG_FOLDER . $pointer))					continue;
							if (!preg_match($regexp, $pointer))	 					continue;
							if (!$this->mg2->checkLanguage($pointer, 'admin'))	continue;

							$value = 'value="'.$pointer.'"';
							if ($this->mg2->defaultlang === $pointer) {
								$value .= ' selected="selected"';
								$exists = true;
							}
							$langs[] = array($value, $pointer);
						}
						closedir($workdir);
					}
					if (!$exists) $langs[] = array('value="" selected="selected"','--');
					sort($langs);

					// GET SKINS
					$exists = false;
					if ($workdir = opendir('skins')) {
						while (false !== ($pointer = readdir($workdir))) {
							if ($pointer{0} === '.')	continue;

							$value = 'value="'.$pointer.'"';
							if ($this->mg2->activeskin === $pointer) {
								$value .= ' selected="selected"';
								$exists = true;
							}
							$skins[] = array($value, ucfirst($pointer));
						}
						closedir($workdir);
					}
					if (!$exists) $skins[] = array('value="" selected="selected"','--');
					sort($skins);

					// IMAGE MAPS TOOLTIPT
					$mapInfo  = '&lt;div style=\\\'width:%dpx;height:%dpx;background:url(%s) no-repeat;\\\'&gt;'.
									'&lt;div style=\\\'text-align:center;height:20px;\\\'&gt;%s&lt;/div&gt;'.
									'&lt;div style=\\\'float:left;width:78px;height:80px;\\\'&gt;'.
									'&lt;div style=\\\'padding:15px 2px;\\\'&gt;%s&lt;/div&gt;'.
									'&lt;/div&gt;'.
									'&lt;div style=\\\'float:right;text-align:right;width:78px;height:80px;\\\'&gt;'.
									'&lt;div style=\\\'padding:15px 2px;\\\'&gt;%s&lt;/div&gt;'.
									'&lt;/div&gt;'.
									'&lt;div style=\\\'clear:both;text-align:center;height:20px;\\\'&gt;'.
									'&lt;div style=\\\'padding-top:6px;\\\'&gt;%s&lt;/div&gt;'.
									'&lt;/div&gt;'.
									'&lt;/div&gt;';
					$mapInfo1 =  sprintf($mapInfo,
												160,
												120,
												ADMIN_IMAGES .'imagemap1.gif',
												$this->mg2->lang['thumbsoverview'],
												$this->mg2->lang['prev'],
												$this->mg2->lang['next'],
												''
									 );
					$mapInfo2 =  sprintf($mapInfo,
												160,
												120,
												ADMIN_IMAGES .'imagemap2.gif',
												$this->mg2->lang['thumbsoverview'],
												$this->mg2->lang['prev'],
												$this->mg2->lang['next'],
												$this->mg2->lang['download']
									 );

					// CONVERT HTML CONTENT TO EDIT (INPUT FIELD)
					$gallerietitle = $this->mg2->htmlchars2entities($this->mg2->gallerytitle);
					$websitetext	= $this->mg2->htmlchars2entities($this->mg2->websitetext);
					$copyright		= $this->mg2->htmlchars2entities($this->mg2->copyright);
					break;

			case 'data':
					// COUNT RECORDS
					$num_folderRC = $this->countItemsOldDB('mg2db_fdatabase.php');	// old folder data
					$num_imageRC  = $this->countItemsOldDB('mg2db_idatabase.php');	// old image data

					// GET BACKUP FILES
					$allBackups = array();
					$urrentTime = time();
					$regexp		= '/^([0-9]{10})_mg2db_([a-z]{5,9})\.php$/i';
					if ($workdir = opendir(BACKUP_FOLDER)) {
						while (false !== ($pointer = readdir($workdir))) {
							if ($pointer{0} === '.')							continue;
							if (!preg_match($regexp, $pointer, $items))	continue;
							if ((int)$items[1] > $urrentTime)				continue;

							switch ($items[2]) {
								case 'fdatabase':
								case 'idatabase': $rename = array(
															'fdatabase' => 'folders',
															'idatabase' => 'items'
														);
														$items[2] = $rename[$items[2]];
														$items[3] = '_v0.3.x';					// kh_mod 0.3.0 b5 up to 0.4.0 b3
								case 'folders':
								case 'items':
								case 'keywords':
								case 'settings':
								case 'counter':	$allBackups[$items[2]][] = $items;
							}
						}
						closedir($workdir);
					}

					// SORT ALL BACKUPS DESCENDING
					foreach ($allBackups as $key => $backup) {
						$this->mg2->sortNumeric($backup, 1, 1);
						$allBackups[$key] = $backup;
					}

					// NUMBER OF COMMENT FILES (LEVEL 1)
					$comments = glob($this->mg2->imagefolder .'/*.comment');
					$comments = $comments ? count($comments):0;
					break;

			case 'stats':
					// LOAD EXIF MODUL
					include_once(INC_FOLDER .'mg2_exif.php');
					$Exif = new MG2Exif();

					// NUMBER OF FOLDERS
					$numFolders = $GLOBALS['totalFolders'];

					// COUNT IMAGES, VIDEOS AND SOUNDS
					$numImages = $numVideos = $numAudios = 0;
					foreach (array_keys($this->mg2->all_items) as $itemID) {
						$contentType = $this->mg2->getContentType($itemID);

						if 	 (isset($contentType['image'])) $numImages++;
						elseif (isset($contentType['video'])) $numVideos++;
						elseif (isset($contentType['audio'])) $numAudios++;
					}

					// IF COUNTER SWITCHED OFF
					if (!($this->mg2->foldersetting & 128) && !($this->mg2->extendedset & 256)) {
						$message = sprintf('%s <a href="%s?display=options&amp;tab=0&amp;fID=%d&amp;page=%s#advanced">&hellip;</a>',
											$this->mg2->lang['counter_inactive'],
											ADMIN_INDEX,
											$folderID,
											$page
									  );
						$this->mg2->displayStatus($message, 1);
					}

					// LOAD AND INITIALIZE STATS CLASS
					require_once(INC_FOLDER .'mg2admin_stats.php');
					$Stats = &$this->mg2->getInstance('MG2Stats');

					// GET POST AND SET SESSION VALUES
					$oldStatisticSets = $this->mg2->statisticsets;
					$numLatestClicks	= $Stats->getDisplNumber('numLatestClicks');
					$numMostItems		= $Stats->getDisplNumber('numMostItems');
					$numMostFolders	= $Stats->getDisplNumber('numMostFolders');
					$numLatestComm		= $Stats->getDisplNumber('numLatestComm');
					$numLatestItems	= $Stats->getDisplNumber('numLatestItems');
					$numLatestFolders	= $Stats->getDisplNumber('numLatestFolders');
					$periodClickStat	= $Stats->getTimePeriod('periodClickStat');
					$periodItems		= $Stats->getTimePeriod('periodItems');
					$periodFolders		= $Stats->getTimePeriod('periodFolders');

					// IF STATISTIC SETS CHANGED THAN SAVE IT
					if (($oldStatisticSets !== $this->mg2->statisticsets) &&
						 $this->mg2->checkVerificationToken('stats'))
					{
						empty($this->mg2->sqldatabase) ?
							$this->mg2->write_sDBFlatfile()
							:
							$this->mg2->SQLWrite->write2SQLTable('settings');
					}

					// IF TIME DISPLAY LOCKED THAN SET DEFAULT VALUE
					$Stats->setDefaultTimeFormat();

					// GET DIRECTORY SIZE
					$dirSize = $this->mg2->convertBytes($Stats->getDirSize(ROOT_FOLDER), 1);
					break;

			case 'server':
					// GET CURRENT MEMORY STATUS
					$this->mg2->getMemoryStatus();

					// GET MYSQL VALUES
					$maxMySQLPacket = '<i>'.$this->mg2->lang['unknown'].'</i>';
					$sessionSQLMode = '<i>'.$this->mg2->lang['unknown'].'</i>';
					if (function_exists('mg2mysql_query')) {

						// MAX ALLOWED MYSQL Packet
						$resultResource = mg2mysql_query("SHOW VARIABLES LIKE 'max_allowed_packet'");
						$resultRecord	 = mg2mysql_fetch_row($resultResource);
						if (isset($resultRecord[1])) {
							$maxMySQLPacket = $this->mg2->convertBytes((int)$resultRecord[1], 1);
						}

						// SESSION SQL MODE
						$resultResource = mg2mysql_query("SHOW VARIABLES LIKE 'sql_mode'");
						$resultRecord	 = mg2mysql_fetch_row($resultResource);
						if (isset($resultRecord[1])) {
							$sessionSQLMode = $resultRecord[1] ?
													$resultRecord[1]
													:
													'<i>'. $this->mg2->lang['noentry'] .'</i>';
						}
					}
					break;

			case 'dailystats':
					// LOAD AND INITIALIZE STATS CLASS
					require_once(INC_FOLDER .'mg2admin_stats.php');
					$Stats     = &$this->mg2->getInstance('MG2Stats');
					$timestamp = (int)$_GET['date'];
					$dailyDate = $Stats->getDailyDate($timestamp);
					$details   = $Stats->getDailyDetails($timestamp);

					// VIEW SETTING
					settype($this->mg2->statisticsets, 'integer');
					$allViews = array(1=>1, 2=>2);
					$currView = ($this->mg2->statisticsets & 1<<20)? 2:1;
					if (isset($_GET['dailyview'])          &&
						 isset($allViews[$_GET['dailyview']]))
					{
						$newView = (int)$_GET['dailyview'];
						if ($currView !== $newView) {
							$this->mg2->statisticsets ^= 1<<20;
							$writeOK = empty($this->mg2->sqldatabase) ?
										  $this->mg2->write_sDBFlatfile()
										  :
										  $this->mg2->SQLWrite->write2SQLTable('settings');
							if ($writeOK) $currView = $newView;
						}
					}
					$inc_array[$tab] = ($currView === 2)?
											 ADMIN_FOLDER .'admin_dailystats_list.php'
											 :
											 ADMIN_FOLDER .'admin_dailystats_thumb.php';

					// IF TIME DISPLAY LOCKED THAN SET DEFAULT VALUE
					$Stats->setDefaultTimeFormat();

					// CALLED AS AJAX CONTENT BY COLORBOX
					if (isset($_GET['cbox'])) {
						include($inc_array[$tab]);
						exit;
					}

					// ADDITIONAL TAB "DAILY STATS"
					$tab_array = array(
										0 => $this->mg2->lang['setup'],
										1 => $this->mg2->lang['data'],
										2 => $this->mg2->lang['stats'],
										5 => $this->mg2->lang['dailystats'],
										3 => $this->mg2->lang['server'],
										4 => $this->mg2->lang['logfile']
									 );
		}

		// DISPLAY OPTIONS MENU
		echo '
			<div class="optionsMenuBox">
			<ul id="optionsMenu">
		';
		$tab_link = '<a href="'. ADMIN_INDEX .'?display=options&amp;tab=%s&amp;fID=%s&amp;page=%s">%s</a>';
		foreach ($tab_array as $key=>$tab_item) {

			if ($key === $tab) {
				$tab_class  = 'selected';
				$tab_text   = $tab_item;
			}
			else {
				$tab_class  = 'unselected';
				$tab_text   = sprintf($tab_link, $key, $folderID, $page, $tab_item);
			}

			printf('
				<li class="%1$s"><span class="%1$s">%2$s</span></li>',
				$tab_class,
				$tab_text
			);
		}
		echo '
			</ul>
			</div>
		';

		// DISPLAY OPTIONS CONTENT
		$optionsContent = is_readable($inc_array[$tab]) ? $inc_array[$tab]:'';
		echo '
			<div class="optionsContent">
		';
			include $optionsContent;
		echo '
			</div>
		';
	}

	// SORTS A TWO DIMENSION ARRAY
	function arrayMultisort(&$data, $columns) {
		$interm = array();
		foreach ($columns as $column => $sort_flag) {
			$tmp = array();
			foreach ($data as $key => $row) {
				$tmp[$key] = $row[$column];
			}
			$interm[] = $tmp;
			$interm[] = $sort_flag;
		}
		$interm[] = &$data;

		call_user_func_array('array_multisort', $interm);
	}

	// NORMALIZE A RELATIVE OR FULL PATH
	function normalizePath($path) {

		$parts    = array();
		$path     = str_replace('\\', '/', $path);
		$path     = preg_replace('/\/{2,}/', '/', $path);
		$nextPart = '';

		foreach(explode('/', $path) as $segment) {
			if($segment === '.') continue;

			$nextPart = array_pop($parts);
			if($nextPart === null) {
				$parts[] = $segment;
			}
			elseif($segment === '..') {
				if($nextPart === '..') {
					$parts[] = $nextPart;
				}

				if($nextPart === '..' || $nextPart === '') {
					$parts[] = $segment;
				}
			}
			else {
				$parts[] = $nextPart;
				$parts[] = $segment;
			}
		}
		return implode('/', $parts);
	}

	// COUNT OLD DATABASE ENTRIES, SECTION: DATA
	function countItemsOldDB($db) {
		$numRecords = 0;
		$dataPath	= ROOT_FOLDER .'/'. $db;
		do {
			if (!is_file($dataPath))				break;
			if (!$fp = fopen($dataPath,'rb'))	break;

			while (!feof($fp)) {
				if (fgets($fp,2) !== '*')			continue;	// no data row
				$record = fgetcsv($fp, 4600, '*');
				if ((int)$record[0] < 1)			continue;	// invalid id
				$numRecords++;
			}
			fclose($fp);
		}
		while(0);

		return $numRecords;
	}
}
?>