<?php
//
// ADMIN REBUILD CLASS
// kh_mod 0.4.0 rc1, add
class MG2Rebuild {

	var $mg2;			// parent object reference
	var $folderID;		// displayed folder
	var $page;			// siplayed page
	var $rebuildID;	// item/folder/keyword IDs
	var $display;		// display below the dialog resp. the result

	// INITIALIZE REBUILD
	function MG2Rebuild(&$parent, $param=array()) {
		$this->mg2		 = &$parent;
		$this->folderID = 1;
		$this->page		 = 1;
	}

	// $Rebuild = &$this->getInstance('MG2Rebuild', array('folderID'=>..., 'page'=>...));
	// foreach($param as $key=>$value) $$key = $value;

	// START REBUILD DIALOG KEYWORD ITEMS
	function askRebuildKeyword($keywordID) {

		// GET KEYWORD INSTANCE
		$Keywords = $this->mg2->getInstance('MG2Keywords');

		// GET ITEMS TO REBUILD
		if (($itemIDs = $Keywords->selectItemIDs($keywordID)) === false) {
			$this->mg2->displayStatus($this->mg2->lang['nokeywordid'] .' #'. $keywordID, 3);
			return false;
		}

		// SET DIALOG VALUES
		$keywordName	  = $Keywords->getKeywordName($keywordID);
		$this->rebuildID = $keywordID;
		$this->display	  = 'keywords';
		$this->message	  = sprintf($this->mg2->lang['import_folder_again'], $keywordName);
		$this->setupURL  = ADMIN_INDEX .'?display=options&amp;fID=1&amp;page=1';
		$this->cancelURL = ADMIN_INDEX .'?display='. $this->display;

		// GET DEFAULT FOLDER ICON
		$this->icon				= $this->mg2->getFolderIcon(1);
		$this->icon['title']	= $this->mg2->lang['keywords'];

		// DISPLAY REBUILD DIALOG
		$this->askRebuildDialog($itemIDs, 'rebuildKeyword');
	}

	// START REBUILD DIALOG BOOKMARKED IMAGES
	function askRebuildBooked() {

		// SET DIALOG VALUES
		$this->rebuildID = 'all';
		$this->display	  = 'bookmarked';
		$this->message	  = sprintf($this->mg2->lang['import_folder_again'], $this->mg2->lang['bookmarked_images']);
		$this->setupURL  = ADMIN_INDEX .'?display=options&amp;fID=1&amp;page=1';
		$this->cancelURL = ADMIN_INDEX .'?display='. $this->display;

		// GET DEFAULT FOLDER ICON
		$this->icon				= $this->mg2->getFolderIcon(1);
		$this->icon['title']	= $this->mg2->lang['bookmarked_images'];

		// GET ITEMS TO REBUILD
		$itemIDs = $this->mg2->selectIndexDB(true, 'all_items', 15);

		// DISPLAY REBUILD DIALOG
		return $this->askRebuildDialog($itemIDs, 'rebuildBooked');
	}

	// START REBUILD DIALOG LAST IMPORTED ITEMS
	function askRebuildImported() {

		// SET DIALOG VALUES
		$this->rebuildID = 'all';
		$this->display	  = 'lastimported';
		$this->message	  = sprintf($this->mg2->lang['import_folder_again'], $this->mg2->lang['lastimported']);
		$this->setupURL  = ADMIN_INDEX .'?display=options&amp;fID=1&amp;page=1';
		$this->cancelURL = ADMIN_INDEX .'?display='. $this->display;

		// GET DEFAULT FOLDER ICON
		$this->icon				= $this->mg2->getFolderIcon(1);
		$this->icon['title']	= $this->mg2->lang['lastimported'];

		// GET ITEMS TO REBUILD
		$itemIDs = $this->mg2->getLastImportedIDs();

		// DISPLAY REBUILD DIALOG
		return $this->askRebuildDialog($itemIDs, 'rebuildImported');
	}

	// START REBUILD DIALOG ITEM
	function askRebuildItem($itemID, $page) {

		// REBUILD ID VALID
		if (!isset($this->mg2->all_items[$itemID])) {
			$this->mg2->displayStatus(sprintf($this->mg2->lang['nopictureid'], $itemID), 3);
			return 1;	// root folder id
		}

		// SET DIALOG VALUES
		$fileName		  = $this->mg2->getFileName($itemID);
		$this->rebuildID = $itemID;
		$this->folderID  = (int)$this->mg2->all_items[$itemID][1];
		$this->page		  = $page;
		$this->display	  = $GLOBALS['display'];
		$this->message	  = sprintf($this->mg2->lang['import_file_again'], $fileName);
		$this->setupURL  = sprintf('%s?display=options&amp;fID=%d&amp;page=%s', ADMIN_INDEX, $this->folderID, $page);
		$this->cancelURL = sprintf('%s?fID=%d&amp;page=%s&amp;display=%s',
									 ADMIN_INDEX,
									 $this->folderID,
									 $page,
									 $this->display
								 );

		// GET ITEM ICON TO REBUILD
		$fileIcon				= $this->mg2->getFileIcon($itemID, null, true);
		$this->icon['path']	= $fileIcon[1];
		$this->icon['attrb']	= 'width="'. $fileIcon[2] .'" height="'. $fileIcon[3] .'"';
		$this->icon['class']	= 'thumb';
		$this->icon['title']	= $fileName;

		// DISPLAY REBUILD DIALOG
		return $this->askRebuildDialog(array($itemID), 'rebuildItem');
	}

	// START REBUILD DIALOG FOLDER
	function askRebuildFolder($folderID, $page) {

		// CHECK FOLDER ID
		if (!isset($this->mg2->all_folders[$folderID])) {
			$this->mg2->displayStatus($this->mg2->lang['nofolderid'] .' #'. $folderID, 3);
			return 1;	// root folder id
		}

		// SET DIALOG VALUES
		$folderName		  = $this->mg2->getFolderName($folderID);
		$this->rebuildID = $folderID;
		$this->folderID  = $folderID;
		$this->page		  = $page;
		$this->display	  = 'tableview';
		$this->message   = sprintf($this->mg2->lang['import_folder_again'], $folderName);
		$this->setupURL  = ADMIN_INDEX .'?display=options&amp;fID='. $folderID .'&amp;page='. $page;
		$this->cancelURL = ADMIN_INDEX .'?fID='. $folderID .'&amp;page='. $page;

		// GET FOLDER ICON
		$this->icon				= $this->mg2->getFolderIcon($folderID);
		$this->icon['title']	= sprintf('%s \'%s\'', $this->mg2->lang['folder'], $folderName);

		// GET ITEMS TO REBUILD
		$itemIDs = $this->mg2->selectIndexDB($folderID, 'all_items', 1);

		// DISPLAY REBUILD DIALOG
		return $this->askRebuildDialog($itemIDs, 'rebuildFolder');
	}

	// REBUILD DIALOG
	function askRebuildDialog($itemIDs, $action) {

		// ARE THERE ITEMS TO REBUILD
		if (empty($itemIDs)) {
			$this->mg2->displayStatus($this->mg2->lang['rebuildempty'], 1);
			return $this->folderID;
		}

		// GET DIALOG VALUES
		$Treeview  = &$this->mg2->getInstance('MG2Treeview');
		$itemsDirs = $Treeview->getItemsDirs();
		$explorer  = $Treeview->buildExplorer($itemsDirs);
		$verify    = $this->mg2->setVerificationToken($action);
		if ($_SESSION[GALLERY_ID]['isJavaScript']) {
			$renameAttrb = 'disabled="disabled"';
			$lableColor  = 'color:grey;';
		}
		else {
			$renameAttrb = 'checked="checked"';
			$lableColor  = '';
		}

		// GET SUB PATH OF EACH ITEM
		foreach ($itemIDs as $itemID) $filepaths[] = $this->mg2->all_items[$itemID][7];

		// GET IMPORT OPTIONS FOR IMAGE SCALING
		$checked = $this->mg2->getResizeOptions('rebuild');

		// DISPLAY DIALOG TEMPLATE
		include(ADMIN_FOLDER .'admin_rebuild.php');

		return $this->folderID;
	}

	// START ITEM REBUILD ACTION
	function rebuildItemStart($itemID) {

		$numTasks = false;

		if (isset($this->mg2->all_items[$itemID])) {
			$numTasks = $this->rebuildStart(array($itemID));
		}
		else {
			$this->mg2->displayStatus(sprintf($this->mg2->lang['nopictureid'], $itemID), 2);
		}

		return $numTasks;
	}

	// START FOLDER REBUILD ACTION
	function rebuildFolderStart($folderID) {

		return ($itemIDs = $this->mg2->selectIndexDB($folderID, 'all_items', 1))?
				 $this->rebuildStart($itemIDs)
				 :
				 $this->mg2->displayStatus($mg2->lang['rebuildempty'], 1);
	}

	// START "BOOKMARKED IMAGES" REBUILD ACTION
	function rebuildBookedStart() {

		return ($itemIDs = $this->mg2->selectIndexDB(true, 'all_items', 15))?
				 $this->rebuildStart($itemIDs)
				 :
				 $this->mg2->displayStatus($this->mg2->lang['rebuildempty'], 1);
	}

	// START KEYWORD REBUILD ACTION
	function rebuildKeywordStart($keywordID) {

		// GET INSTANCE KEYWORD
		$Keywords = &$this->mg2->getInstance('MG2Keywords');

		return ($itemIDs = $Keywords->selectItemIDs($keywordID))?
				 $this->rebuildStart($itemIDs)
				 :
				 $this->mg2->displayStatus($this->mg2->lang['rebuildempty'], 1);
	}

	// START "LAST IMPORTED ITEMS" REBUILD ACTION
	function rebuildImportedStart() {

		return ($itemIDs = $this->mg2->getLastImportedIDs())?
				 $this->rebuildStart($itemIDs)
				 :
				 $this->mg2->displayStatus($this->mg2->lang['rebuildempty'], 1);
	}

	// PREPARE THUMB AND MEDIUM IMAGES TO RESIZE ACTION
	function rebuildStart($itemIDs) {

		// INIT START VALUES
		require_once(INC_FOLDER .'mg2admin_itemprocess.php');
		$ItemProcess = new MG2ItemProcess($this->mg2);
		$options     = $this->getRebuildOptions();
		$newSubdir   = $options['subdir'];
		$duplicates  = array();

		// DELETE AND MOVE ACTIONS
		foreach ($itemIDs as $itemID) {

			// GET ITEM DATA
			$itemRC			 = &$this->mg2->all_items[$itemID];
			$itemFileName	 = trim($itemRC[6]);
			$itemSubdir		 = trim($itemRC[7]);
			$itemFilePath	 = $this->mg2->getFilePathByName($itemFileName, $itemSubdir);
			$newFileName	 = $itemFileName;

			// DOSEN'T EXIST ITEM FILE
			if (!is_file($itemFilePath)) {
				$message = sprintf($this->mg2->lang['rebuildmissed'], $itemID, $itemFileName);
				$this->mg2->displayStatus($message, 2);
				continue;
			}

			// IF NEW SUB DIRECTORY SELECTED (SERVER)
			if ($newSubdir					!== false										&&
				 strtolower($newSubdir) !== strtolower($itemSubdir)				&&
				 is_file($this->mg2->getFilePathByName($itemFileName, $newSubdir)))
			{
				// RENAME EXISTING FILE
				if ($options['rename']) {
					$fileExt = strrchr($itemFileName, '.');
					$regexp  = '/(_?\((\d{1,12})\))?'. preg_quote($fileExt) .'$/i';
					if (!preg_match($regexp, $itemFileName, $appendix))	continue;	// file syntax error

					$i = ((int)$appendix[2] > 1000000)? 0:(int)$appendix[2];
					$baseName = substr($itemFileName, 0, -strlen($appendix[0]));
					$changeTo = $baseName .'_(%d)'. $fileExt;
					do {
						$newFileName = sprintf($changeTo, ++$i);
					}
					while (is_file($this->mg2->getFilePathByName($newFileName, $newSubdir)));
				}
				// FILE ALREADY EXISTS IN NEW FOLDER
				else {
					$duplicates[] = $itemFilePath; 								continue;
				}
			}

			// DELETE THE OLD THUMB AND MEDIUM IMAGE
			$deleteOK = $this->mg2->deleteThumbMedium($itemFileName, $itemSubdir);
			if ($deleteOK === false)												continue;

			// IF NEW SUB DIRECTORY SELECTED (SERVER)
			do {
				if ($newSubdir === false || $newSubdir === $itemSubdir)					break;	// no new item subdir

				$newFilePath = $this->mg2->getFilePathByName($newFileName, $newSubdir);
				if (!rename($itemFilePath, $newFilePath))										break;	// couldn't move item to new dir

				$oldCommPath  = $this->mg2->getFilePathByName($itemFileName, $itemSubdir, 'comment');
				$itemFileName = $newFileName;
				$itemSubdir   = $newSubdir;
				if (!is_file($oldCommPath))														break;	// there is no comment file

				$newCommPath = $this->mg2->getFilePathByName($itemFileName, $newSubdir, 'comment');
				if (rename($oldCommPath, $newCommPath))										break;	// move comment ok

				$this->mg2->displayStatus(sprintf($this->mg2->lang['commentnotmoved'],
													 $oldCommPath,
													 $this->mg2->imagefolder . $newSubdir
												 ), 2);
			}
			while(0);

			// SET REBUILD TASK
			$rebuildTasks = &$_SESSION[GALLERY_ID]['rebuildTasks'];
			$modify		  = $options['modify'];
			$itemRC[6]	  = $itemFileName;
			$itemRC[7]	  = $itemSubdir;
			$ItemProcess->addItemProcessTask($itemID, $modify);
		}

		// DUPLICATE MESSAGE
		if ($duplicates) {
			$bullet  = '<span style="display:block;text-align:left">'. $this->mg2->lang['bullet'] .'&nbsp;';
			$message = sprintf(
								'<span style="display:inline-block;vertical-align:top;">
									<span style="display:block;">'. $this->mg2->lang['duplicatefiles'] .'</span>
									'. $bullet .'%s</span>
								 </span>
								',
								count($duplicates),
								$newSubdir ? substr($newSubdir, 1):$this->mg2->imagefolder,
								implode('</span>'. $bullet, $duplicates)
						  );
			$this->mg2->displayStatus($message, 1);
		}

		// ARE THERE REBUILD TASKS
		if ($numTasks = count($rebuildTasks)) {

			// WRITE ITEM DATA
			if ($this->mg2->write_iDB('upd', array_keys($rebuildTasks)) < 1) {
				$this->mg2->displayStatus($this->mg2->lang['iDB_error'], 3);
			}

			// CREATE THUMBNAIL RSP. MEDIUM IMAGE
			$ItemProcess->doItemProcessList();
		}

		return $numTasks;
	}

	// GET NEW SUBDIR FOR REBUILD
	function getRebuildOptions() {

		// GET NEW SUBDIR
		$newSubdir = trim($_POST['newdir']);
		if	(((int)$newSubdir === -1)				||		// subdir not changed
			  !$this->mg2->getImportDir($newSubdir))	// new import dir invalid
		{
			$newSubdir = false;
		}

		// GET IMAGE SCALING OPTIONS
		if (isset($_POST['rebuildID'])) {
			$modify  = (isset($_POST['thumb'])  && (int)$_POST['thumb']	 === 1)? 1:0;
			$modify |= (isset($_POST['medium']) && (int)$_POST['medium'] === 1)? 2:0;
			$modify |= (isset($_POST['delete']) && (int)$_POST['delete'] === 1)? 4:0;
			$_SESSION[GALLERY_ID]['rebuild_modify'] = $modify;
		}
		else {
			$modify = 3;
		}

		// GET RENAME OPTION
		$rename = (isset($_POST['rename']) && (int)$_POST['rename'] === 1)?
					 true
					 :
					 false;

		return array(
					'subdir'	=> $newSubdir,
					'modify'	=> $modify,
					'rename'	=> $rename
				 );
	}
}
?>