<?php
///////////////////////////////////////////////////////////////////////////////////
//                                                                               //
//	kh_mod                                                                        //
//	A PHP/SQL image gallery script based on MG2                                   //
//	http://www.minigal.de													                  //
//	support@minigal.de                                                            //
//                                                                               //
//	Project started: Oct/01 2006                                                  //
//                                                                               //
//    kh_mod is free software; you can redistribute it and/or modify             //
//    it under the terms of the GNU General Public License as published by       //
//    the Free Software Foundation version 2.                                    //
//                                                                               //
///////////////////////////////////////////////////////////////////////////////////

class SQLWrite {

	var $mg2;	// parent object reference

	// INITIALIZE SQLWRITE
	function SQLWrite(&$parent) {
		$this->mg2 = &$parent;
	}

	// WRITE MySQL DATABASE
	function write2SQLTable($table, $action='all', $recordIDs=false) {

		// USE DIFFERENT RECORDS AND $records IS NOT AN ARRAY?
		if ($action !== 'all' && !is_array($recordIDs)) return -1;

		$result = -1;
		switch ($table) {
			case 'folders':
				switch ($action) {
					case 'new':
					case 'upd':
						$values = array();
						foreach ($recordIDs as $folderID) {
							if (!array_key_exists($folderID, $this->mg2->all_folders)) continue;
							$record	 = $this->mg2->all_folders[$folderID];
							$values[] = $this->getSQLValues($table, $record);
						}
						$query = 'REPLACE INTO `mg2db_'. $table .'` VALUES'. implode(',', $values);
						if (mg2mysql_query($query)) $result = mg2mysql_affected_rows();
						break;
					case 'all':
						$query	= 'TRUNCATE TABLE `mg2db_'. $table .'`'; if (!mg2mysql_query($query)) break;
						$towrite	= 0;
						$writeOk	= 0;
						foreach ($this->mg2->all_folders as $record) {
							$towrite++;
							$query = 'INSERT INTO `mg2db_'. $table .'` VALUES'. $this->getSQLValues($table, $record);
							if (mg2mysql_query($query)) $writeOk++;
						}
						if ($writeOk === $towrite) $result = $writeOk;
						break;
					case 'del':
						$query = 'DELETE FROM `mg2db_'. $table .'` WHERE folderID IN ('.
									implode(',', $recordIDs)
									.')';
						if (mg2mysql_query($query)) $result = mg2mysql_affected_rows();
						break;
					default: $this->mg2->status = 'Could not write into table `mg2db_'. $table .'`';
				}
				break;
			case 'items':
				switch ($action) {
					case 'new':
					case 'upd':
						$values = array();
						foreach ($recordIDs as $imageID) {
							if (!array_key_exists($imageID, $this->mg2->all_items)) continue;
							$record	 = $this->mg2->all_items[$imageID];
							$values[] = $this->getSQLValues($table, $record);
						}
						$query = 'REPLACE INTO `mg2db_'. $table .'` VALUES'. implode(',',$values);
						if (mg2mysql_query($query)) $result = mg2mysql_affected_rows();
						break;
					case 'all':
						$query	= 'TRUNCATE TABLE `mg2db_'. $table .'`'; if (!mg2mysql_query($query)) break;
						$towrite	= 0;
						$writeOk	= 0;
						foreach ($this->mg2->all_items as $record) {
							$towrite++;
							$query = 'INSERT INTO `mg2db_'. $table .'` VALUES'. $this->getSQLValues($table, $record);
							if (mg2mysql_query($query)) $writeOk++;							
						}
						if ($writeOk === $towrite) $result = $writeOk;
						break;
					case 'del':
						$query = 'DELETE FROM `mg2db_'. $table .'` WHERE itemID IN ('.
									implode(',', $recordIDs)
									.')';
						if (mg2mysql_query($query)) $result = mg2mysql_affected_rows();
						break;
					default: $this->mg2->status = 'Could not write into table `mg2db_'. $table .'`';
				}
				break;
			case 'settings':
				$query  = 'REPLACE INTO `mg2db_'. $table .'` VALUES'. $this->getSQLValues($table);
				$result = (mg2mysql_query($query))? true:false;
				break;
			default: $this->mg2->status = $this->mg2->lang['nodbselected'];
		}
		return $result;
	}

	// GET VALUES FOR WRITE FOLDER DATABASE
	function getSQLValues($table, $record='') {

		$result = '';
		switch ($table) {
			// FOLDER DATA
			case 'folders':
				return  sprintf("(
								%d ,'%s','%s','%s', %d , %d, %d, %d ,'%s',%d ,%d , %d,'%s'
								)",
								$record[0],			// folder id
								trim($record[1]),	// 'root' or parent folder id
								mg2mysql_real_escape_string(trim($record[2])),
								mg2mysql_real_escape_string(trim($record[3])),
								$record[4],
								$record[5],
								$record[6],
								$record[7],
								mg2mysql_real_escape_string(trim($record[8])),
								$record[9],
								$record[10],
								isset($record[11]) ? $record[11]:0,
								isset($record[12]) ? mg2mysql_real_escape_string(trim($record[12])):''
						  );
			// ITEM DATA
			case 'items':
				return  sprintf("(
								%d ,'%d','%s','%s', %d , %d ,'%s','%s', %d,
								%d , %d , %d , %d , %s ,'%s', %d , %d
								)",
								$record[0],		// item id
								$record[1],		// parent folder id
								mg2mysql_real_escape_string(trim($record[2])),
								mg2mysql_real_escape_string(trim($record[3])),
								$record[4],
								$record[5],
								mg2mysql_real_escape_string(trim($record[6])),
								mg2mysql_real_escape_string(trim($record[7])),
								$record[8],
								$record[9],
								$record[10],
								$record[11],
								$record[12],
								$record[13] ? (int)$record[13]:'NULL',
								mg2mysql_real_escape_string(trim($record[14])),
								$record[15],
								$record[16]
						  );
			// SETTING DATA
			case 'settings':
				return  sprintf("(1,
								'%s','%s', %d ,'%s','%s','%s','%s', %d , %d , %d ,
								 %d , %d ,'%s','%s','%s', %d ,'%s','%s','%s','%s',
								'%s','%s', %d , %d , %d , %d , %d , %d , %d ,'%s',
								'%s', %d , %d , %d ,'%s', %d
								)",
								mg2mysql_real_escape_string(trim($this->mg2->gallerytitle)),
								mg2mysql_real_escape_string(trim($this->mg2->adminemail)),
								$this->mg2->metasetting,
								trim($this->mg2->defaultlang),
								trim($this->mg2->activeskin),
								trim($this->mg2->dateformat),
								trim($this->mg2->timeformat),
								$this->mg2->navtype,
								$this->mg2->showexif,
								$this->mg2->commentsets,

								$this->mg2->foldersetting,
								$this->mg2->marknew,
								mg2mysql_real_escape_string(trim($this->mg2->copyright)),
								mg2mysql_real_escape_string(trim($this->mg2->adminpwd)),
								mg2mysql_real_escape_string(trim($this->mg2->adminsalt)),
								$this->mg2->extensions,
								mg2mysql_real_escape_string(trim($this->mg2->canvasWidth)),
								mg2mysql_real_escape_string(trim($this->mg2->contentWidth)),
								mg2mysql_real_escape_string(trim($this->mg2->introWidth)),
								mg2mysql_real_escape_string(trim($this->mg2->mediumimage)),

								mg2mysql_real_escape_string(trim($this->mg2->indexfile)),
								mg2mysql_real_escape_string(trim($this->mg2->imagefolder)),
								$this->mg2->layoutsetting,
								$this->mg2->thumbquality,
								$this->mg2->thumbMaxWidth,
								$this->mg2->thumbMaxHeight,
								$this->mg2->itemThumbCols,
								$this->mg2->itemThumbRows,
								$this->mg2->slideshowdelay,
								mg2mysql_real_escape_string(trim($this->mg2->websitelink)),

								mg2mysql_real_escape_string(trim($this->mg2->websitetext)),
								$this->mg2->inactivetime,
								$this->mg2->extendedset,
								$this->mg2->statisticsets,
								mg2mysql_real_escape_string(trim($this->mg2->modversion)),
								$this->mg2->installdate
						  );
			default: $this->mg2->log('ERROR: Could not create values for sql table \''.$table.'\'.');
		}
		return $result;
	}
}
?>