<?php
////////////////////////////////////////////////////////
//       DISPLAY FOLDER AND IMAGE TABLE (ADMIN)       //
////////////////////////////////////////////////////////

	// LOAD VIEWTABLE HELPER CLASS
	require_once(INC_FOLDER .'mg2admin_tableview_helper.php');
	$ViewtableHelper = &$this->getInstance('MG2ViewtableHelper', $folderID);

	// BUILD FOLDER STRUCTURE AND ALLOCATE ITEMS
	$ViewtableHelper->buildDataStructure();

	// GET CONTAINED FOLDERS AND ITEMS, kh_mod 0.4.0 b4, add
	$folderIDs	= $ViewtableHelper->getSubFolderIDs();
	$itemIDs		= $ViewtableHelper->getItemIDs();
	$totalItems	= count($itemIDs);
	$this->getFolderSettings($folderID);
	$this->sortIndexDB($folderIDs, 'all_folders', $this->folderSortMode);
	$this->sortIndexDB($itemIDs, 'all_items', $this->imageSortMode);

	// GET COLS AND ROWS PER PAGE
	$itemCols = $this->getThumbCols($folderID);			// values {1 ... n}
	$itemRows = $this->getThumbRows($folderID);			// values {1 ... n}

	//CALCULATE ICONS PER PAGE AND NUMBER OF PAGES
	$maxItems = $itemCols * $itemRows;						// max items per page
	$numPages = max(ceil($totalItems / $maxItems), 1);	// number of pages

	// CALCULATE FIRST AND LAST INDEX OF PAGE
	if ($currentPage === 'all') {
		$first	 = 0;
		$numItems = $totalItems;
	}
	else {
		$currentPage = min($currentPage, $numPages);
		$first		 = $maxItems * ($currentPage - 1);
		$numItems	 = min($totalItems - $first, $maxItems);
	}

	// ITEM IDs OF THE CURRENT PAGE
	$itemIDs = array_slice($itemIDs, $first, $numItems);

	// DISPLAY TABLE HEADER
	$tableHead = '';
	if ($this->folderPosition < 0) {				// folder locked?
		$tableHead = ' bgcolor="#FFCFCF" title="'. $this->lang['nodisplay'];
		$tableHead.= ' ('. $this->lang['position'] .' '. $this->folderPosition .')"';
	}
	elseif ($this->folderPublish > time()) {	// folder published not yet?
		$tableHead = ' bgcolor="#FFFF99" title="'. $this->lang['notpublished'];
		$tableHead.= ' '. $this->time2date($this->folderPublish) .'"';
	}
	include(ADMIN_FOLDER .'admin_table_start.php');

	// DISPLAY FOLDER ROWS
	$ViewtableHelper->displayFolderRows($folderIDs, $currentPage);

	// DISPLAY ITEM ROWS
	$ViewtableHelper->displayItemRows($itemIDs, $currentPage);

	// DISPLAY CONTROLS
	include(ADMIN_FOLDER .'admin_controls.php');
?>
