<?php
	// DISPLAY ERRORS BUT HIDE WARNINGS AND NOTICES
	error_reporting(E_ERROR | E_PARSE);

	session_start();

	// DEFINE UPDATE PATHS
	define('ROOT_FOLDER',	dirname(__FILE__));
	define('INC_FOLDER',		ROOT_FOLDER .'/includes/');
	define('DATA_FOLDER',	ROOT_FOLDER .'/data/');
	define('BACKUP_FOLDER',	ROOT_FOLDER .'/data/backup/');
	define('LANG_FOLDER',	ROOT_FOLDER .'/lang/');
	define('ADDON_FOLDER',	ROOT_FOLDER .'/addons/');
	define('ADMIN_FOLDER',	'./admin/');
	define('UPDATE_INDEX',	$_SERVER['SCRIPT_NAME']);
	define('ADMIN_IMAGES',	'./admin/images/');
	define('MAXLEN_PWD',    4096);

	// SET HTTP HEADERS
	header('X-Frame-Options: DENY');
	header('Expires: Mon, 20 Jul 2000 05:00:00 GMT');
	header('Last-Modified: '. gmdate('D, d M Y H:i:s') .' GMT');
	header('Content-Type: text/html; charset=utf-8');
	header('Content-Style-Type: text/css');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: post-check=0, pre-check=0', false);
	header('Pragma: no-cache');

	// BUILD NEW DATABASE OBJECT
	require(INC_FOLDER .'mg2_functions.php');
	require(INC_FOLDER .'mg2admin_functions.php');
	require(INC_FOLDER .'mg2admin_update.php');
	$mg2    = new MG2admin();
	$Update = &$mg2->getInstance('MG2AdminUpdate');

	// NEW MOD VERSION (SCRIPT)
	$updateVersion = '0.4.5';

	// INCLUDE UPDATE/INSTALL HEADER
	$charset   = 'utf-8';
	$pagetitle = 'Update to kh_mod '. $updateVersion;
	require(ADMIN_FOLDER .'install_header.inc.php');
?> 
	<table class="install_table" cellpadding="0" cellspacing="0" summary="Update MG2/kh_mod">
	<tr valign="top">
		<td align="center" colspan="4">
		<div style="margin-top:2.3em;">
			<p style="font-size:large;">
				<strong>Update from MG2 0.5.0/0.5.1 or kh_mod &lt; <?php echo $updateVersion;?></strong>
			</p>
<?php
	// GET UPDATE STEP
	$updateStep = (empty($_POST['step']))?
					  1
					  :
					  max((int)$_POST['step'], 1);

	do {
		// GET SETTINGS
		if (!$Settings = $Update->getSettings($updateStep)) {
			$Update->displayUpdateError(); break;
		}

		// READ LANGUAGE FILES
		$Settings->defaultlang = $Update->readLanguage($Settings);

		// UPDATE MESSAGE
		if ($updateStep < 3) {
			echo
				'<p>This script will update your gallery to kh_mod '
				. $updateVersion .
				' in 2 easy steps.</p>'
			;
		}

		// CHECK PASSWORD
		if (!$Update->updateSecurity($Settings)) {
			$Update->inputPassword();      break;
		}

		// START UPDATE
		if     ($updateStep === 1) {
			$Update->updateStep1($Settings, $updateVersion);	// do update settings
		}
		elseif ($updateStep === 2) {
			$Update->updateStep2($Settings->imagefolder);		// do select gallery data to convert
		}
		elseif ($updateStep === 3) {
			$Update->updateStep3($updateVersion);					// do convert gallery data
		}
	}
	while(0);
?> 
		</div>
		</td>
	</tr>
	</table>
</body>
</html>